#!/usr/bin/perl

BEGIN
{
       my ($dirprg,$nameprg) = $0 =~ /(.+)\/(.+)/;
       unshift (@INC,"$dirprg/../../lib");
}

use Getopt::Long;
use ParamParser;
use Logger;
use strict;
use warnings;
use Program ;


MAIN:
{
	my $o_param = New ParamParser('GETOPTLONG',"cfg=s", "seq=s");
	$o_param->SetUsage(my $usage=sub { &Usage(); } );
	$o_param->AssertFileExists('cfg');
	$o_param->Update($o_param->Get('cfg'),'A');
	$o_param->AssertFileExists('seq');
	my $seq_file=$o_param->Get('seq');

	
	my $logger = New Logger ($o_param->Get('log'),"DE",'NOCOMPRESSION');
	$logger->Trace("Begin Learn :\n",$logger->CalcStamp,"DE");

	mkdir($o_param->Get('path_new_release'));
	my $rnafold= New Program($o_param->Get('R_FOLD_name'), $o_param->Get('R_FOLD_cmd'),$o_param->Get('R_FOLD_param'),$o_param->Get('R_FOLD_type'), $o_param->Get('R_FOLD_version'), \$logger,$logger->CalcStamp);

  	$rnafold->SetInOut($seq_file,$seq_file."out");
    	print $rnafold->GetCmd();
 	$rnafold->Run;
}
=item Usage

	$o_param->Usage();
	Print the usage of the program

=cut

sub Usage
{
print STDERR<<END
Usage:
$0	
	--help  : 	this message
	--cfg	: 	path configuration file
	--seq   : 	path of a fasta sequence file

END
}