#!/usr/bin/perl

BEGIN
{
       my ($dirprg,$nameprg) = $0 =~ /(.+)\/(.+)/;
       unshift (@INC,"$dirprg/../../lib");
}

use strict;
use warnings;
use Range ;
use Sequence;
use ParamParser;
MAIN:
{
 	my $o_param = New ParamParser('GETOPTLONG',"cfg=s", "seq=s");
	$o_param->SetUsage(my $usage=sub { &Usage(); } );
	$o_param->AssertFileExists('cfg');
	$o_param->Update($o_param->Get('cfg'),'A');
	$o_param->AssertFileExists('seq');
	my $seq_file=$o_param->Get('seq');

	my $seq= New Sequence("$seq_file");

	$seq->Initialize("Seq1","SeqTest","1",$o_param->Get('specie'),"today",undef);
	$seq->SetSequence();
	print "Oject sequence : ";
	$seq->Print();


	my $range1= New Range();
	$range1->Initialize(12,85,"-",\$seq);
	print "RANGE1 : \n";
	$range1->Print();
    	my $range2= New Range();
	$range2->Initialize(12,85,"+",\$seq);
	print "RANGE2 : \n";
	$range2->Print();
}
=item Usage

	$o_param->Usage();
	Print the usage of the program

=cut

sub Usage
{
print STDERR<<END
Usage:
$0	
	--help  : 	this message
	--cfg	: 	path configuration file
	--seq   : 	path of a fasta sequence file

END
}