#!/usr/bin/perl

BEGIN
{
       my ($dirprg,$nameprg) = $0 =~ /(.+)\/(.+)/;
       unshift (@INC,"$dirprg/../../lib");
}

use strict;
use warnings;
use Sequence;
use ParamParser;

MAIN:
{
	my $o_param = New ParamParser('GETOPTLONG',"cfg=s", "seq=s");
	$o_param->SetUsage(my $usage=sub { &Usage(); } );
	$o_param->AssertFileExists('cfg');
	$o_param->Update($o_param->Get('cfg'),'A');
	$o_param->AssertFileExists('seq');
	my $seq_file=$o_param->Get('seq');

	my $seq= New Sequence("$seq_file");

	$seq->Initialize("Seq1","SeqTest","1",$o_param->Get('specie'),"today",undef);
	$seq->SetSequence();
	print "Oject sequence : ";
	$seq->Print()
}
=item Usage

	$o_param->Usage();
	Print the usage of the program

=cut

sub Usage
{
print STDERR<<END
Usage:
$0	
	--help  : 	this message
	--cfg	: 	path configuration file
	--seq   : 	path of a fasta sequence file

END
}
