<?xml version="1.0" encoding="iso-8859-1"?>
<!-- Affiche le detail d'un arn en fonctiond'un fichier rnaml-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html"/>
<xsl:param name="url"/>
<xsl:param name="fnt_family"/>
<xsl:param name="url_annot"/>
<xsl:param name="link_genbank"/>
<xsl:param name="link_rfam"/>
<xsl:param name="index_car_substr_img"/>
	<xsl:template match="/">
		<xsl:apply-templates/>
	</xsl:template>
	
	<!-- Demarage du premier tag : rnaml et traitement des noeuds suivants -->
	<xsl:template match="rnaml">
		<xsl:apply-templates select="molecule" mode="titre"/>
		<!--  Analyses utilisées pour detection des arn (affichage en dernier) -->
		<h2 class="learn">Analyses : </h2>
		<div class="div_learn">
		<table>
		<xsl:apply-templates select="analysis"/>
		</table>
		</div>
	</xsl:template>

	<xsl:template match="molecule" mode="titre">
		<!--  En titre : accession de la molecule -->
		<h1 class="learn"><xsl:value-of select="@id"/></h1>

		<!--  Description de l'ARN -->
		<h2 class="learn">Sequence : </h2>
		<div class="div_learn">
		<table>
			<tr>
				<td><label class="text1">Id:</label> </td>	
				<td><xsl:value-of select="./identity/name"/></td>
				<td><label class="text1">Organism:</label> </td>	
				<td><i><xsl:value-of select="./identity/taxonomy/species"/></i></td>
			</tr>
			
			<tr>
				<td><label class="text1">Comment:</label></td>	
				<td><xsl:value-of select="@comment"/></td>
				<td><label class="text1">LeARN family: </label></td>
				<td>	
					<xsl:element name='a'>
						<xsl:attribute name='href'>
							<xsl:value-of select="$url"/>
							<xsl:text>&amp;__wb_function=</xsl:text>
							<xsl:value-of select="$fnt_family"/>
							<xsl:text>&amp;FamilyDisplay=</xsl:text>
							<xsl:value-of select="./structure/@comment"/>
						</xsl:attribute>
						<xsl:value-of select="./structure/@comment"/>
					</xsl:element>
				</td>
			</tr>
			<tr>
				<xsl:apply-templates select="/rnaml/database-entry[@id=/rnaml/molecule/@database-ids]" mode="link_dbxref"/>
				<td><label class="text1">Last updated:</label> </td>	
				<td><xsl:apply-templates select="/rnaml/revision/date" /></td>
			</tr>
			<!--  on teste que la database entry correspond bien à le lien dbxref qui est dans /rnaml/molecule/@database-ids...-->
			<tr>
				<td><label class="text1">Status:</label></td>	
				<td> <xsl:value-of select="./identity/@comment"/></td>
				<td><label class="text1">Length:</label> </td>	
				<td><xsl:apply-templates select="./sequence[@comment='primary']/@length" /></td>
			</tr>
	
			<tr>
				<!-- detected on  ACC start-end (strand)-->
				<xsl:apply-templates select="./sequence[@comment='primary']/numbering-system" />
				<!-- Program-->
				<td><label class="text1">Detected by:</label> </td>	
				<td><xsl:value-of select="./sequence[@comment='primary']/@analysis-ids"/></td>
			</tr>
		</table>
		<xsl:apply-templates select="./sequence[@comment='primary']/seq-data" />
	 	
	 	<!-- boucle por afficher chaque sequences correctement-->
		<xsl:if test="./sequence[@comment='secondary']">
			<label class="text1">Ranges secondaires : </label><br />
			<xsl:for-each select="./sequence[@comment='secondary']">
				<pre>
				<xsl:apply-templates select="./numbering-system" mode="secondary" />
				<br />
				<xsl:apply-templates select="./seq-data" mode="secondary" />
				</pre>
			</xsl:for-each>
		</xsl:if>
		</div>
		
		<xsl:apply-templates select="structure" />
		
		<xsl:if test="./sequence[@comment='primary']/seq-annotation">
			<h2 class="learn">Segment annotations: </h2>
			<div class="div_learn">
			<ul>
				<xsl:for-each select="./sequence[@comment='primary']/seq-annotation">
					<li class="under_space">
					<xsl:value-of select="./segment/base-id-5p/base-id/position"/>
					<xsl:text> - </xsl:text><xsl:value-of select="./segment/base-id-3p/base-id/position"/>   
					<xsl:text>  </xsl:text>
					<xsl:element name='a'>
					<xsl:attribute name='target'>
						<xsl:text>blank</xsl:text>
					</xsl:attribute>
					<xsl:attribute name='href'>
						<xsl:value-of select="$url_annot"/>
						<xsl:text>&amp;RnaDisplay=</xsl:text>
						<xsl:value-of select="/rnaml/molecule/@id"/>
						<xsl:text>&amp;Start=</xsl:text>
						<xsl:value-of select="./segment/base-id-5p/base-id/position"/>
						<xsl:text>&amp;End=</xsl:text>
						<xsl:value-of select="./segment/base-id-3p/base-id/position"/>
						<xsl:text>&amp;Title=</xsl:text>
						<xsl:value-of select="./segment/seg-name"/>
					</xsl:attribute>
					<xsl:attribute name='class'>
						<xsl:text>button</xsl:text>
					</xsl:attribute>
					<xsl:text>Plot</xsl:text>
				</xsl:element>
				</li>
				<ul>
				<li><xsl:text>Description: </xsl:text><xsl:value-of select="./segment/seg-name"/></li>
				<li><xsl:text>Annotator : </xsl:text><xsl:value-of select="./@comment"/></li>
				<xsl:if test="contains(./segment/@comment,'TIMESTAMP=')">
					<li><xsl:text>Date : </xsl:text>
					<xsl:value-of  select="substring-after(substring-before(./segment/@comment, ' '), '=')"/>
					</li>
				</xsl:if>
				<xsl:if test="contains(./segment/@comment,'LEGEND=')">
					<li class="under_space"><xsl:text>Comment : </xsl:text>
					<xsl:value-of  select="substring-after(substring-after(./segment/@comment, ' '), '=')"/>
					</li>
				</xsl:if>
				</ul>
				
				</xsl:for-each>
				</ul>
				<center>
				<xsl:element name='a'>
					<xsl:attribute name='target'>
						<xsl:text>blank</xsl:text>
					</xsl:attribute>
					<xsl:attribute name='href'>
						<xsl:value-of select="$url_annot"/>
						<xsl:text>&amp;RnaDisplay=</xsl:text>
						<xsl:value-of select="/rnaml/molecule/@id"/>
					</xsl:attribute>
					<xsl:attribute name='class'>
						<xsl:text>button</xsl:text>
					</xsl:attribute>
					<xsl:text>Plot all annotations</xsl:text>
				</xsl:element>
				</center>
				<br /><br />
			</div>
		</xsl:if>
		
	</xsl:template>

	<xsl:template match="numbering-system">
		<td>
		<label class="text1"/>
		<xsl:element name='a'>
   			<xsl:attribute name='href'>
				<xsl:value-of select="$link_genbank"/>
				<xsl:text>&amp;val=</xsl:text>
   	        		<xsl:value-of select="@id"/>
   		    	</xsl:attribute>
     		    	<xsl:attribute name='target'>
	     		   	<xsl:text>blank</xsl:text>
     		    	</xsl:attribute>
   		  		<xsl:value-of select="@id"/>
			</xsl:element>
		</td>
		<td>
			<xsl:apply-templates select="numbering-range" />
			<xsl:text> (</xsl:text><xsl:value-of select="/rnaml/molecule/sequence[@comment='primary']/@strand"/><xsl:text>)</xsl:text>
		</td>
	</xsl:template>
	
	<xsl:template match="numbering-system" mode="secondary" >
		<xsl:text>&gt;</xsl:text>
		<xsl:value-of select="@id" /><xsl:text>-</xsl:text>
		<xsl:value-of select="numbering-range/start" /><xsl:text>-</xsl:text>
		<xsl:value-of select="numbering-range/end" /><xsl:text>-</xsl:text>
		<xsl:choose>
			<xsl:when test="../@strand='-'">
				<xsl:text>m</xsl:text>
			</xsl:when>
			
			<xsl:otherwise>
				<xsl:text>p</xsl:text>
			</xsl:otherwise>
		</xsl:choose>		
	</xsl:template>

	<xsl:template match="numbering-range">
			<xsl:apply-templates select="start" />
			<xsl:apply-templates select="end" />		
	</xsl:template>

	<xsl:template match="start">
		<xsl:value-of select="."/>
	</xsl:template>
	<xsl:template match="end">
		<xsl:text> - </xsl:text><xsl:value-of select="."/><xsl:text> </xsl:text>
	</xsl:template>

	<xsl:template match="/rnaml/database-entry" mode="link_dbxref">
		<td><label class="text1">Dbxref:</label></td>
		<td>
		<xsl:choose>
			<!--  On fait un lien sur rfam scan si dbxref=~Rfam -->
			<xsl:when test="./database='Rfam'">
				<xsl:element name='a'>
					<xsl:attribute name='href'>
						<xsl:value-of select="$link_rfam"/>
						<xsl:value-of select="./entry"/>
					</xsl:attribute>
					<xsl:attribute name='target'>
						<xsl:text>blank</xsl:text>
					</xsl:attribute>
					<xsl:value-of select="@id"/>
				</xsl:element>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="@id"/>
			</xsl:otherwise>
		</xsl:choose>		
		</td>
	</xsl:template>
	
	<xsl:template match="seq-annotation">
		<p class="node" >
			<label class="text1">Annotations :</label>
			
		</p>
	</xsl:template>
	
	
	<!--  Decoupage de seq_data en chaine de 60 car cf PrintFamily.xsl pour explications -->
	<xsl:template match="seq-data">
		<p class="node" >
		<pre>
			<xsl:text>&gt;</xsl:text>
			<xsl:value-of select="/rnaml/molecule/@id"/><br/>
			<xsl:call-template name="cut">
				<xsl:with-param name="string" select="."/>
			</xsl:call-template>
		</pre>
	</p>
	</xsl:template>
	 
	 <xsl:template match="seq-data" mode="secondary">
		<xsl:call-template name="cut">
			<xsl:with-param name="string" select="."/>
		</xsl:call-template>
	</xsl:template>
	<xsl:template match="structure">
		<h2 class="learn">Structure : </h2>
		<div class="div_learn">
		<table>
		<tr valign="top">
			<td><br/><label class="text1">Structure computed by: </label>	
			<xsl:value-of select="@analysis-ids"/><br/>
			<label class="text1">Free-energie:</label>
			<xsl:value-of select="./model/model-info/free-energy"/><br/><br/>
			<xsl:if test="contains(./model/str-annotation/@comment,'PARENTHESIS=')">
				<label class="text1">Parenthesis structure: </label><br/>
				<pre>
				<xsl:call-template name="cut">
					<xsl:with-param name="string" select="substring-before(substring-after(./model/str-annotation/@comment, '='), ' ')"/>
				</xsl:call-template>
				</pre>
			</xsl:if>
			</td>
			<td>
				<xsl:apply-templates select="./model/secondary-structure-display" />
			</td>
		
		
		</tr>
		
		</table>
		</div>
	</xsl:template>

	
	<xsl:template match="secondary-structure-display">
	<!-- pour afficher l'image, on crée un element IMG eavec les attributs correspondants-->
		<p class="node">
			<xsl:element name='img'>
		    <xsl:attribute name='src'><xsl:value-of select="substring(@comment,$index_car_substr_img,string-length(@comment))"/></xsl:attribute>
		    <xsl:attribute name='class'>ss</xsl:attribute>
			</xsl:element>
	</p>
	</xsl:template>

	<xsl:template match="analysis">
		<tr>
			<td><label class="text1">Program:</label><b><xsl:value-of select="./program/prog-name"/> v<xsl:value-of select="./program/prog-version"/></b></td>
		<td><label class="text1">Running date:</label>
		<xsl:apply-templates select="date" /></td>
		</tr>
	</xsl:template>

	<xsl:template match="date">
		<xsl:value-of select="./day"/>/<xsl:value-of select="./month"/>/<xsl:value-of select="./year"/>
	</xsl:template>

	<xsl:template name="cut">
		<!-- template de saucisonnage. Navigue sur le modele et non le fichier source, la chaîne à découper étant passée en paramètre -->
		<xsl:param name="string"/>
		<!-- determine la rondelle a decouper -->
		<xsl:choose>
			<xsl:when test="string-length($string) > 50">
				<xsl:value-of select="substring($string, 1,50)"/><br/>
				<xsl:variable name="rest">
					<xsl:value-of select="substring($string, 51, string-length($string))"/>
				</xsl:variable>
				<!-- relancer le processus de saucisonnage sur les éléments suivants du modèle -->
				<xsl:call-template name="cut">
			 		<xsl:with-param name="string" select="$rest"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				 <xsl:value-of select="$string"/><br/>
			</xsl:otherwise>
		</xsl:choose>
		<!-- détermine le reste du saucisson -->
		
	</xsl:template>

</xsl:stylesheet>
