<?xml version="1.0" encoding="iso-8859-1"?>
<!-- Affiche la liste complete des ARN-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html"/>
<xsl:param name="url"/>
<xsl:param name="fnt_rna"/>
<xsl:param name="fnt_family"/>
<xsl:param name="wks_rna"/>
<xsl:param name="wks_family"/>
<xsl:param name="wks_previous"/>

<xsl:variable name="color">0</xsl:variable>
<xsl:template match="/">
	<xsl:apply-templates/>
</xsl:template>

	<xsl:template match="rnaml">
		<tr class="{concat('line', $color)}">
		<xsl:apply-templates select="molecule" mode="titre"/>
		</tr>
	</xsl:template>

	<xsl:template match="molecule" mode="titre">
		<td>
		<xsl:element name='a'>
			<xsl:attribute name='href'>
				<xsl:value-of select="$url"/>
				<xsl:text>&amp;__wb_function=</xsl:text>
				<xsl:value-of select="$fnt_rna"/>
				<xsl:text>&amp;__wb_workspace=</xsl:text>
				<xsl:value-of select="$wks_rna"/>
				<xsl:text>&amp;RnaDisplay=</xsl:text>
				<xsl:value-of select="@id"/>
				<xsl:text>&amp;__wb_wks_previous=</xsl:text>
				<xsl:value-of select="$wks_previous"/>
			</xsl:attribute>
			<xsl:value-of select="@id"/>
		</xsl:element>
		</td>
		<td>
			<xsl:value-of select="identity/name"/>
		</td>
		<td class="presentation">
		<xsl:element name='a'>
			<xsl:attribute name='href'>
				<xsl:value-of select="$url"/>
				<xsl:text>&amp;__wb_function=</xsl:text>
				<xsl:value-of select="$fnt_family"/>
				<xsl:text>&amp;FamilyDisplay=</xsl:text>
				<xsl:value-of select="./structure/@comment"/>
				<xsl:text>&amp;__wb_workspace=</xsl:text>
				<xsl:value-of select="$wks_family"/>
				<xsl:text>&amp;__wb_wks_previous=</xsl:text>
				<xsl:value-of select="$wks_previous"/>
			</xsl:attribute>
			<xsl:value-of select="./structure/@comment"/>
		</xsl:element>
		</td>
		<xsl:apply-templates select="sequence" />
		<xsl:apply-templates select="structure" />
	</xsl:template>
	

	<xsl:template match="sequence">
	<xsl:if test="@comment='primary'">
		<xsl:apply-templates select="numbering-system" />
		<!-- detected by-->
		<td>
			<xsl:value-of select="@analysis-ids"/> 
		</td>
	</xsl:if>
	</xsl:template>

	<xsl:template match="numbering-system">
		<!-- detected on-->
		<td>
		<xsl:value-of select="@id"/>
   		</td>
		<xsl:apply-templates select="numbering-range" />
	</xsl:template>

	<xsl:template match="numbering-range">
		<xsl:apply-templates select="start" />
		<xsl:apply-templates select="end" />		
	</xsl:template>

	<xsl:template match="start">
		<td><xsl:value-of select="."/></td>
	</xsl:template>

	<xsl:template match="end">
		<td><xsl:value-of select="."/></td>
	</xsl:template>


	<xsl:template match="structure">
		<xsl:apply-templates select="./model/model-info/free-energy" />
	</xsl:template>
	<xsl:template match="free-energy">
		<td class="presentation"><xsl:value-of select="."/></td>
	</xsl:template>
	
	

</xsl:stylesheet>
