<?xml version="1.0" encoding="iso-8859-1"?>
<!-- Affiche la liste des familles selon l'ACC, avec nom (lien hypertexte vers le detail),commentaire, longueur,-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html"/>
<xsl:param name="url"/>
<xsl:param name="fnt"/>
<xsl:param name="org"/>

<xsl:template match="/">
	<xsl:choose>
      	<xsl:when test="$org='Any' or $org=''">
		<xsl:apply-templates select="rnaml"/>
	</xsl:when>
	<xsl:when test="$org=/rnaml/molecule/identity/taxonomy/species">
		<xsl:apply-templates select="rnaml"/>
	</xsl:when>
	</xsl:choose>
</xsl:template>

	<xsl:template match="rnaml">
	<tr class="line1">
		<xsl:apply-templates select="molecule-class" />
	</tr>
	</xsl:template>


	<xsl:template match="molecule-class" >
		<xsl:apply-templates select="numbering-system"/>
		<td> <xsl:value-of select="./identity/name"/></td>
		<td> <xsl:value-of select="@database-ids"/></td>
		<td> <xsl:value-of select="./alignment/@comment"/></td>
		<td> <xsl:value-of select="./numbering-system/numbering-range/length"/></td>
		<td> <xsl:value-of select="./consensus-molecule/molecule/structure/model/model-info/free-energy"/></td>
	</xsl:template>
	<!-- pour creer le lien, on crée un element A avec les attributs correspondants-->
	
	<xsl:template match="numbering-system">
		<td>
		<xsl:element name='a'>
		<xsl:attribute name='href'>
			<xsl:value-of select="$url"/>
			<xsl:text>&amp;__wb_function=</xsl:text>
			<xsl:value-of select="$fnt"/>
			<xsl:text>&amp;FamilyDisplay=</xsl:text>
			<xsl:value-of select="@id"/>
		</xsl:attribute>
		<xsl:value-of select="@id"/>
		</xsl:element>
		</td>
	</xsl:template>
</xsl:stylesheet>
