<?xml version="1.0" encoding="iso-8859-1"?>
<!-- Affiche la liste complete des ARN-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html"/>
<xsl:param name="url"/>
<xsl:param name="fnt_rna"/>
<xsl:param name="fnt_family"/>
<xsl:param name="link_genbank"/>
<xsl:param name="org"/>

<xsl:template match="/">
	<xsl:choose>
      <xsl:when test="$org='Any' or $org=''">
			<xsl:apply-templates select="rnaml"/>
		</xsl:when>
	  	<xsl:otherwise>
			<xsl:apply-templates select="rnaml[/rnaml/molecule/identity/taxonomy/species=$org]"/>
	  	</xsl:otherwise>
   </xsl:choose>
</xsl:template>

	<xsl:template match="rnaml">
		<tr class="line0">
			<xsl:apply-templates select="molecule" mode="titre"/>
  		</tr>
	</xsl:template>

	<xsl:template match="molecule" mode="titre">
		<td>
		<xsl:element name='a'>
			<xsl:attribute name='href'>
				<xsl:value-of select="$url"/>
				<xsl:text>&amp;__wb_function=</xsl:text>
				<xsl:value-of select="$fnt_rna"/>
				<xsl:text>&amp;RnaDisplay=</xsl:text>
				<xsl:value-of select="@id"/>
			</xsl:attribute>
			<xsl:value-of select="@id"/>
		</xsl:element>
		</td>
		<td><xsl:value-of select="@database-ids"/></td>
		<xsl:apply-templates select="identity/name" />
		<xsl:apply-templates select="sequence" />
		<xsl:apply-templates select="structure" />
	</xsl:template>
		
	<xsl:template match="identity/name">
		<td><xsl:value-of select="."/></td>
	</xsl:template>
	<xsl:template match="sequence">
	<xsl:if test="@comment='primary'">
		<xsl:apply-templates select="numbering-system" />
		<!-- detected by-->
		<td>
		<xsl:value-of select="@analysis-ids"/>
		</td>
	</xsl:if>
	</xsl:template>

	<xsl:template match="numbering-system">
		<!-- detected on-->
		<td>
		<xsl:element name='a'>
			<xsl:attribute name='href'>
				<xsl:value-of select="$link_genbank"/>
				<xsl:text>&amp;val=</xsl:text>
				<xsl:value-of select="@id"/>
			</xsl:attribute>
			<xsl:attribute name='target'>
				<xsl:text>blank</xsl:text>
			</xsl:attribute>
			<xsl:value-of select="@id"/>
		</xsl:element>
		
		</td>
		<xsl:apply-templates select="numbering-range" />
	</xsl:template>

	<xsl:template match="numbering-range">
		<xsl:apply-templates select="start" />
		<xsl:apply-templates select="end" />	
                <td class="presentation"><xsl:value-of select="/rnaml/molecule/sequence[@comment='primary']/@strand"/>	</td>	
	</xsl:template>

	<xsl:template match="start">
		<td><xsl:value-of select="."/></td>
	</xsl:template>

	<xsl:template match="end">
		<td><xsl:value-of select="."/></td>
	</xsl:template>


	<xsl:template match="structure">
	<!-- family -->
	<xsl:apply-templates select="./model/model-info/free-energy" />
	<td>
	<xsl:element name='a'>
		<xsl:attribute name='href'>
			<xsl:value-of select="$url"/>
			<xsl:text>&amp;__wb_function=</xsl:text>
			<xsl:value-of select="$fnt_family"/>
			<xsl:text>&amp;FamilyDisplay=</xsl:text>
			<xsl:value-of select="@comment"/>
		</xsl:attribute>
		<xsl:value-of select="@comment"/>
	</xsl:element>
	</td>
	</xsl:template>
	<xsl:template match="free-energy">
		<td><xsl:value-of select="."/></td>
	</xsl:template>
	
	

</xsl:stylesheet>

