#!/usr/bin/perl -I../lib
#
# $Id$
#

# Copyright INRA

# Celine.Noirot@toulouse.inra.fr
# Thomas.Schiex@toulouse.inra.fr
# Christine.Gaspin@toulouse.inra.fr
# Jerome.Gouzy@toulouse.inra.fr

# This software is a computer program whose purpose is to provide a
# web-based system for detecting, clustering and annotating non protein
# coding RNA genes.

# This software is governed by the CeCILL license under French law and
# abiding by the rules of distribution of free software.  You can  use,
# modify and/ or redistribute the software under the terms of the CeCILL
# license as circulated by CEA, CNRS and INRIA at the following URL
# "http://www.cecill.info".

# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability.

# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or
# data to be ensured and,  more generally, to use and operate it in the
# same conditions as regards security.

# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL license and that you accept its terms.



BEGIN
{
	my ($dir,$file) = $0 =~ /(.+)\/(.+)/;
	push(@INC,"$dir/../lib");
}


use ParamParser;
use WebBuilder;
use CGI;
use CGI::Carp qw/fatalsToBrowser/;

use LibForCgi;
use Learn;
use Logger;
use strict;
#use EditRna;
my $CGI= new CGI;

my $O_PARAM_CGI = New ParamParser('CGIPM');
$O_PARAM_CGI->SetUnlessDefined('__wb_cfg','../cfg/LearnCgi.cfg');
$O_PARAM_CGI->AssertFileExists('__wb_cfg');

my $O_PARAM_CGI_Learn = New ParamParser($O_PARAM_CGI->Get('__wb_cfg'));

my $RH_WEBBUILDER;
our $LOGGER_LEVEL_EXEC = 'DE';

my $DIR_WORKSPACE;

# path from relative to a workspace
my ($RNA_XML_DIR,$FAMILY_XML_DIR,$XSL_DIR);

MAIN:
{
	$O_PARAM_CGI->SetUnlessDefined('__wb_xmlstructure',$O_PARAM_CGI_Learn->Get('cgi_file_param_xml'));
	$O_PARAM_CGI->SetUnlessDefined('__wb_function','PrintHomepage');
	$O_PARAM_CGI->SetUnlessDefined('__wb_main_menu',$O_PARAM_CGI->Get('__wb_function'));
	$O_PARAM_CGI->SetUnlessDefined('__wb_workspace','public');
	$O_PARAM_CGI->SetUnlessDefined('__wb_cookie','');	
	$O_PARAM_CGI->AssertFileExists('__wb_xmlstructure');
	$DIR_WORKSPACE=$O_PARAM_CGI_Learn->Get('dir_learn')."/".$O_PARAM_CGI_Learn->Get('cgi_dir_release');
	# Verification des parametre du cfg de learn
	print $CGI->header();
	print "<body>";
	my $rna_id=$O_PARAM_CGI->Get('RnaDisplay');
	my $session_space=$O_PARAM_CGI->Get('SessionPath');
	my ($oldout, $olderr) = &CloseStd();	
	
	my $application=&LoadRnaObject($rna_id, $O_PARAM_CGI_Learn->Get('cgi_param_learn_cfg'), $session_space, $DIR_WORKSPACE , $O_PARAM_CGI_Learn->Get('cgi_mask_cfg_release'), $O_PARAM_CGI_Learn->Get('cgi_mask_cfg_old_release'), -1,"view");
	
	my $o_rna=$application->GetRna($rna_id);
	$o_rna->SaveRnaml($session_space."/".$application->{'__o_param'}->Get('path_db_learn_rna_xml'), $session_space."/".$application->{'__o_param'}->Get('path_db_learn_rna_tmp'));
	$o_rna->Print();
	
	# on remodifie les path des fichier associer  l'arn 
	$o_rna->GetStructure()->SetPathsSS($session_space."/".$application->{'__o_param'}->Get('path_db_learn_rna_ss'));
print "<br /><br /><br />";
	$application->PrintPrograms();
	print "<br /><br /><br />";
	my $r_plot=&Learn::GetRefProgram("R_PLOT", "actual");
	
	my $param="";
	my $name;
	if ($O_PARAM_CGI->IsDefined('Start') && $O_PARAM_CGI->IsDefined('End'))
	{
		my $start = $O_PARAM_CGI->Get('Start');
		my $end= $O_PARAM_CGI->Get('End');
		$param="--pre \"$start $end 10 0.1 0.85 0.85 omark\"";
		$name="$rna_id"."_$start"."_$end.jpg";
	}
	else
	{
		my $nb=$o_rna->GetNbAnnotations();
		foreach my $i (0..$nb)
		{
			my $o_annot=$o_rna->GetAnnotate($i);
			$param.=$o_annot->GetStart()." ".$o_annot->GetEnd()." 10 0.1 0.85 0.85 omark ";
			$name="$rna_id"."_all.jpg";
		}
		$param ="--pre \"$param\"";
	}
	print "<br /> PARAM: $param<br />";
	$$r_plot->SetParam($param);
	
	$o_rna->GetStructure()->SetImage($session_space."/".$application->{'__o_param'}->Get('path_db_learn_rna_img')."/$name");
	$o_rna->SetProgForStructure($r_plot);
	$o_rna->ComputeStructure();
	&OpenStd($oldout, $olderr) ;
	print '<h1 class="learn">RNA annotation : '.$O_PARAM_CGI->Get('Title').'</h1>	
		<img src="'.substr($o_rna->GetStructure()->GetImage(),$O_PARAM_CGI_Learn->Get('cgi_param_substr')-1).'" class="ss">';
	print "</body></html>";
}


