#!/usr/bin/perl -I../lib
#
# $Id$
#

# Copyright INRA

# Celine.Noirot@toulouse.inra.fr
# Thomas.Schiex@toulouse.inra.fr
# Christine.Gaspin@toulouse.inra.fr
# Jerome.Gouzy@toulouse.inra.fr

# This software is a computer program whose purpose is to provide a
# web-based system for detecting, clustering and annotating non protein
# coding RNA genes.

# This software is governed by the CeCILL license under French law and
# abiding by the rules of distribution of free software.  You can  use,
# modify and/ or redistribute the software under the terms of the CeCILL
# license as circulated by CEA, CNRS and INRIA at the following URL
# "http://www.cecill.info".

# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability.

# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or
# data to be ensured and,  more generally, to use and operate it in the
# same conditions as regards security.

# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL license and that you accept its terms.



BEGIN
{
	my ($dir,$file) = $0 =~ /(.+)\/(.+)/;
	unshift (@INC,"$dir/../lib");
}

 
use HTML::Entities;
use ParamParser;
use WebBuilder;
use CGI;
use CGI::Carp qw/fatalsToBrowser/;
use LibForCgi;
use Learn;
use Logger;
use Auth;
use JgoughPhylo; # phylogenetic tree design
use strict;
#use EditRna;
&ParamParser::Decode();
my $CGI= new CGI;
my $O_PARAM_WB = New ParamParser('INIT');
$O_PARAM_WB->SetAuthorizedCharacters('[>/0-9a-zA-Z:_.@+\#\-\s=,\?\(\);]');
$O_PARAM_WB->Update('CGIPM','A');
$O_PARAM_WB->SetUnlessDefined('__wb_cfg',"../cfg/LearnCgi.cfg");
$O_PARAM_WB->AssertFileExists('__wb_cfg');

my $O_PARAM_CGI = New ParamParser($O_PARAM_WB->Get('__wb_cfg'));
my @alphabet=split ('', "abcdefghijklmnopqrstuvwyz");
my $RH_WEBBUILDER;
our $LOGGER_LEVEL_EXEC = 'DE';
my $O_AUTH; # objet d'authentification
my $DIR_WORKSPACE;
my $DIV_CLASS;
use Var;
#use vars qw($Var::E_XML $Var::E_ALN $Var::E_STO $Var::Var::E_MUL $Var::E_FA $Var::E_MSS $Var::E_IMG);

# path from relative to a workspace
my ($cgi_dir_rnaml_rna,$cgi_dir_rnaml_family,$cgi_dir_xsl);

MAIN:
{
	$O_PARAM_WB->SetUnlessDefined('__wb_xmlstructure', $O_PARAM_CGI->Get('cgi_file_param_xml') );
	$O_PARAM_WB->SetUnlessDefined('__wb_function','PrintHomepage');
	$O_PARAM_WB->SetUnlessDefined('__wb_main_menu',$O_PARAM_WB->Get('__wb_function'));
	$O_PARAM_WB->SetUnlessDefined('__wb_workspace','public');
	my $clean_ws = $O_PARAM_WB->Get('__wb_workspace');
	$clean_ws =~ s/#.+//;
	$O_PARAM_WB->Set('__wb_workspace',$clean_ws);
	$O_PARAM_WB->SetUnlessDefined('__wb_cookie','');	
	$O_PARAM_WB->AssertFileExists('__wb_xmlstructure');
	
	if  ($O_PARAM_WB->Get('__wb_function') eq "PrintConnexion" && $O_PARAM_WB->Get('launch_form') ne "Login") 
	{
		$O_PARAM_WB->Delete('__wb_cookie');
		$O_PARAM_WB->Delete('__wb_cookie_name');
	}

	$O_PARAM_CGI->SelectNameSpace("cgi_privilege_");
	my @a_key_privilege=$O_PARAM_CGI->GetKeys('\d+');
	my @a_privilege;
	foreach my $key (@a_key_privilege)
	{
		$a_privilege[$key]=$O_PARAM_CGI->Get($key);
 	}
	$O_PARAM_CGI->SelectNameSpace("");
	$O_AUTH=New Auth({login		=>	$O_PARAM_WB->Get('__login'),
			password	=>	$O_PARAM_WB->Get('__passwd'),
			file		=>	$O_PARAM_CGI->Get('cgi_file_etcpassword'),
			cookie		=>	$O_PARAM_WB->Get('__wb_cookie'),
			cookie_name	=>	$O_PARAM_WB->Get('__wb_cookie_name'),
			list_privilege	=> 	\@a_privilege }
			 );
	
	$O_PARAM_WB->Set('__wb_cookie',$O_AUTH->GetCookie() );
	$O_PARAM_WB->Set('__wb_cookie_name',$O_AUTH->GetCookieName() );
	$RH_WEBBUILDER = New WebBuilder($O_PARAM_WB);



	if ($O_AUTH->GetPrivilege() < 1 && $O_PARAM_WB->Get('__wb_workspace') ne "session"  ) # si on est pas connectee
	{
		$O_PARAM_WB->Set('__wb_workspace',"public");
	}
	if  ($O_PARAM_WB->Get('__wb_main_menu') eq "PrintAnalyse" && $O_PARAM_WB->Get('__wb_function') ne "DisplayRna" && $O_PARAM_WB->Get('__wb_workspace') eq "session" )
	{	
		$O_PARAM_WB->Set('__wb_workspace',$O_PARAM_WB->Get('__wb_wks_previous') );
	}
	#WORKSPACE
	if ($O_PARAM_WB->Get('__wb_workspace') eq "public" )
	{
		$DIR_WORKSPACE=$O_PARAM_CGI->Get('dir_learn')."/".$O_PARAM_CGI->Get('cgi_dir_release');
		$DIV_CLASS='';
	}
	elsif ($O_PARAM_WB->Get('__wb_workspace') =~ /[private|session]/ ) 
	{
		$DIR_WORKSPACE=$O_AUTH->GetWorkspace();
		$DIV_CLASS='<style type="text/css"> body { background-color:#F0F8FF;}
				#wb_header1 { background-color:#F0F8FF;}
				.wb_sub { background-color:#F0F8FF;}
				</style>
				';
	}




	# initialise le flag pour savoir si le bornes ont ete modifiee ou pas / a
	if  ($O_PARAM_WB->Get('__wb_function') eq "EditRna")
	{	# si non definie
		$O_PARAM_WB->SetUnlessDefined('__wb_bounds_changed',0);
	}

	# traitement recopie de learn dans le workspace
	if  ( ($O_PARAM_WB->Get('__wb_function') eq "PrintDBStatus") && ($O_PARAM_WB->IsDefined('reload_private') ) && ($O_PARAM_WB->Get('__wb_workspace') eq "private" )) 
	{
		my $cmd;
		if (-d $DIR_WORKSPACE)
		{
			$cmd = "rm -rf $DIR_WORKSPACE";
			system $cmd;
		}
		$cmd = "mkdir $DIR_WORKSPACE";
		system $cmd;
		$cmd = "cp -r ".$O_PARAM_CGI->Get('dir_learn')."/".$O_PARAM_CGI->Get('cgi_dir_release')."/* $DIR_WORKSPACE";
		system $cmd;
	}
	
	if ($O_PARAM_WB->Get('__wb_function') eq "PrintResultSearchSequence")
	{
		$RH_WEBBUILDER->ClearSession();
	}

	# Verification des parametre du cfg de learn
	$cgi_dir_rnaml_rna=$O_PARAM_CGI->Get('cgi_dir_rnaml_rna');
	$cgi_dir_rnaml_family=$O_PARAM_CGI->Get('cgi_dir_rnaml_family');
	$O_PARAM_CGI->AssertDirExists('cgi_dir_xsl');
	$cgi_dir_xsl=$O_PARAM_CGI->Get('cgi_dir_xsl');
	$RH_WEBBUILDER->SetDocumentStyleSheet($DIV_CLASS);
	#$RH_WEBBUILDER->UnsetBehaviour('encoded_url');
	$RH_WEBBUILDER->Realize();
	#&Trace();
}


=head2 procedure PrintForm

 Title        : PrintForm
 Prerequisite : 
 Function     : Print a form with all hidden data needed by webbuilder.
 		Print input string and if $form is set don't write the open balise FORM
 Args         : $main : name of the main function for WebBuilder
 		$function : name of the function for WebBuilder
 		$string_input : Html code with input data you want to insert in form.
 		$form : string if not defined writes the open balise form
 
=cut

sub PrintForm
{
	my ($main,$function, $string_inputs, $form) = (@_);
	if (! defined ($form))
	{
		print '<FORM action="'.$RH_WEBBUILDER->GetCgi().'" method="post">';
	}
	print $string_inputs;
	print ' <INPUT name="__wb_main_menu" value="'.$main.'" type="hidden" >
		<INPUT name="__wb_function" value="'.$function.'" type="hidden" >
		<INPUT name="__wb_session" value="'.$O_PARAM_WB->Get('__wb_session').'" type="hidden" >
		<INPUT name="__wb_workspace" value="'.$O_PARAM_WB->Get('__wb_workspace').'" type="hidden" >
		<INPUT name="__wb_xmlstructure" value="'.$O_PARAM_WB->Get('__wb_xmlstructure').'" type="hidden" >
		<INPUT name="__wb_cookie" value="'.$O_AUTH->GetCookie().'" type="hidden" >
		<INPUT name="__wb_cookie_name" value="'.$O_AUTH->GetCookieName().'" type="hidden" >
		<INPUT name="__wb_cfg" value="'.$O_PARAM_WB->Get('__wb_cfg').'" type="hidden" >
		</FORM> ';		
}

=head2 procedure PrintConnexion

 Title        : PrintConnexion
 Prerequisite : none
 Function     : Print form of connexion  and after clic log print if connexion is succeed else print failed and form.

=cut 

sub PrintConnexion
{

	print '<h1 class="learn"> Connexion </h1>';
	my $cgi = $RH_WEBBUILDER->GetCgi();

	if ($O_AUTH->GetPrivilege() > 0 ) # si on est connect�
	{
		#$O_AUTH->Print();
		print '<h1 class="learn">succeed<br><br> now, click on the status tab to switch between private and public database</h1>';
	}
	else # affichage du formulaire
	{
		print '<p class="error"> failed </p>'	if ($O_PARAM_WB->Get('Login') eq "Login");
		print '<div name="learn" class="div_learn">';
		my $string_inputs='<center>	
			<p><TABLE class="presentation" >
				<tr>
					<td>
						<LABEL class="label_seq">Login</LABEL>
					</td>
					<td>
						<INPUT type="text" name="__login" class="saisie_seq"/><br />
					</td>
				</tr>
				<tr>
					<td>
						<LABEL class="label_seq">Password </LABEL>
					</td>
					<td>
						<INPUT type="password" name="__passwd" class="saisie_seq"/><br />
					</td>
				</tr>
				<tr>
			</TABLE></p>
			<INPUT type="submit" name="Login"  value="Login" class="button" > 
			<INPUT type="reset" name="Cancel"  value="Reset" class="button"></center>';
		# en post  il faut faire passer tout les parametres / test effectuer avec action contenant cgi + les valeurs inchang�es(ne fonctionne pas)
		&PrintForm($O_PARAM_WB->Get('__wb_main_menu'), $O_PARAM_WB->Get('__wb_function'),$string_inputs);
		print '</div>';
	}
	
}


=head2 procedure SelectWorkspace

 Title        : SelectWorkspace
 Prerequisite : none
 Function     : Print form to choose the viewving workspace : public or private to an user.
 Args         : $fn : name of the fonction wich will be call on clic on form (for WebBuilder)
 				$menu : name of the menu (for WebBuilder)
 
=cut 


sub SelectWorkspace
{	
	my ($menu, $fn)=@_;

	
	my ($class_pub, $class_priv) = ("button", "button");
	if ($O_PARAM_WB->Get('__wb_workspace') eq "public" )
	{
		$class_pub="button_activated";
	}
	elsif ($O_PARAM_WB->Get('__wb_workspace') eq "private" )
	{
		$class_priv="button_activated";
	}
	my $string_inputs=' <INPUT type="submit" name="__wb_workspace"  value="public" class="'.$class_pub.'" > 
						<INPUT type="submit" name="__wb_workspace"  value="private" class="'.$class_priv.'">';
	&PrintForm($menu, $fn,$string_inputs);
		

}


=head2 procedure PrintBrowseFamilies

 Title        : PrintBrowseFamilies
 Prerequisite : none
 Function     : Print the list of family of $DIR_WORKINGSPACE, propose to merge/delete families if it's a private workspace.
 
=cut 

sub PrintBrowseFamilies
{
	my $workspace=$O_PARAM_WB->Get('__wb_workspace') ;
	
	if ($O_AUTH->GetPrivilege() > 0  )
	{
		&SelectWorkspace($O_PARAM_WB->Get('__wb_main_menu'),$O_PARAM_WB->Get('__wb_function') );
	}
	
	my $param="";
	if ($workspace eq "private" )
	{
		$param=' --stringparam checkbox 1 '; # check box for merging family
	}
	
	my $dir_to_analyse=$DIR_WORKSPACE."/".$O_PARAM_CGI->Get('cgi_dir_rnaml_family');
	print '<h1 class="learn">RNA families browser</h1>';
	my $string_inputs="";
	if ($workspace eq "private" ) # ouverture du formulaire pour les checkbox
	{
		print '<FORM action="'.$RH_WEBBUILDER->GetCgi().'" method="post">';
	}
	# Command : extraction des donn�es
	my $url = $RH_WEBBUILDER->GetUrl('__wb_function');
	my $result=$RH_WEBBUILDER->GetSessionPath()."/ViewingFamilies".$O_AUTH->GetPrivilege().".xhtml";
	#if (!-e $result  || -z $result)
	#{
	my $param= $param. ' --stringparam url "'.$url. '" --stringparam fnt DisplayFamily';
	my $cmd = "find $dir_to_analyse -name '*.xml' -exec ". $O_PARAM_CGI->Get('cgi_prg_xsl')." $param $cgi_dir_xsl/". $O_PARAM_CGI->Get('cgi_xsl_print_families') ." \'{}\' \\; > $result";
#print "$cmd <br />";
	`$cmd`;
	#}
	if (-e $result &&  ! -z $result)
	{

		
		print '<center>
			<table class="presentation">	
			<tbody><tr class="head">
			<th></th>';
		print '<th>Merge</th>' if ($workspace eq "private" );
		print '<th>Family acc</th>
			<th>Computed Id</th>
			<th>DbxRef</th>
			<th>Members</th>
			<th>Length</th>
			<th>Free energie</th>
			</tr>';
		&DisplayResult($result, "numbering");
		print ' </tbody>
			</table>	
		   </center>';
	
		if ($workspace eq "private" )
		{
			my $string_inputs='<center><INPUT type="submit" value="Merge" class="button" >
			<INPUT type="reset" class="button" value="Reset" ><center>';
			# en post  il faut faire passer tout les parametres / test effectuer avec action contenant cgi + les valeurs inchang�es(ne fonctionne pas)
			&PrintForm($O_PARAM_WB->Get('__wb_main_menu'), "BrowseMergeFamily",$string_inputs, "noaction");
		}
	}
	else
	{
		print '<p class="error">No result</p>';
	}

}


=head2 procedure BrowseMergeFamily

 Title        : BrowseMergeFamily
 Prerequisite : Only in annotator mode and in private workspace
 Function     : After merging, print the families merged and detail of the result family
 				Then propose you to save it in your workspace.
 
=cut 

sub BrowseMergeFamily
{
	print '<h1 class="learn">Merging</h1>';
	print '<h2 class="learn">Merged families :</h2>';
	my $session_dir=$RH_WEBBUILDER->GetSessionPath();
	#construit la liste des familles
	#print "session_dir: $session_dir; DIR_WORKSPACE: $DIR_WORKSPACE \n";
	my (@lst_of_family)=($O_PARAM_WB->GetKeys("RFL"));

	my $url = $RH_WEBBUILDER->GetUrl('__wb_function');
	my $param=' --stringparam url "'.$url. '" --stringparam fnt DisplayFamily'.' --stringparam checkbox 0';

	my $dir_to_analyse=$DIR_WORKSPACE."/".$O_PARAM_CGI->Get('cgi_dir_rnaml_family');
	my $cmd ;
	my $result=$RH_WEBBUILDER->GetSessionPath()."/ViewingFamilyTmp.xhtml";
	# entete tableau
	print '<center><table class="presentation">	<tbody><tr class="head">
		<th>Family acc</th><th>Computed Id</th><th>DbxRef</th><th>Members</th><th>Length</th><th>Free energie</th>
		</tr>';
	foreach my $fam (@lst_of_family)
	{
		$cmd = $O_PARAM_CGI->Get('cgi_prg_xsl')." $param $cgi_dir_xsl/". $O_PARAM_CGI->Get('cgi_xsl_print_families') ." $dir_to_analyse/$fam.xml > $result";
		#print $cmd;
		`$cmd`;
		&DisplayResult($result)
	}
	print '</table></center>';
	# cr�e le fichier cfg
	
	my $cfgFile=&MakeCfg($O_PARAM_CGI->Get('cgi_param_learn_cfg'),$session_dir, $DIR_WORKSPACE, $O_PARAM_CGI->Get('cgi_mask_cfg_release'), $O_PARAM_CGI->Get('cgi_mask_cfg_old_release'), "Merge");
	my $cde=$O_PARAM_CGI->Get('cgi_prg_learn_merge_family')." --cfg $cfgFile ".$O_PARAM_CGI->Get('cgi_param_learn') ." --families '".join(";",@lst_of_family)."' "; 
	#print $cde;
	`$cde`;
	my $min_fam_acc=&MinElt(@lst_of_family);
	#$MODE_DISPLAY="compute";
	$O_PARAM_WB->Set('FamilyDisplay',$min_fam_acc);
	my $save_wks=$DIR_WORKSPACE;
	$DIR_WORKSPACE=$RH_WEBBUILDER->GetSessionPath();
	&DisplayFamily("NoEdit");
	$DIR_WORKSPACE= $save_wks;
	
	my $string_inputs='<center>
	<INPUT name="button_valid" type="submit" value="Save in '.$O_AUTH->GetLogin().' workspace" class="button" >
	<INPUT name="button_cancel" type="submit" value="Cancel" class="button" ><center>
	<INPUT name="families" value="'.join(";",@lst_of_family).'" type="hidden" />';
	# en post  il faut faire passer tout les parametres / test effectuer avec action contenant cgi + les valeurs inchang�es(ne fonctionne pas)
	&PrintForm($O_PARAM_WB->Get('__wb_main_menu'), "MergeInPrivateRepository",$string_inputs);
}

=head2 procedure MinElt

 Title        : MinElt
 Prerequisite : none
 Function     : return the min accession number
 
=cut 

sub MinElt
{
	my (@a_fam)=(@_);
	my $min_elt=$a_fam[0];
	foreach my $acc (@a_fam) 
	{
		if ($acc lt $min_elt ) 
		{
			$min_elt=$acc;
		}
	}
	return ($min_elt);
}




=head2 procedure MergeInPrivateRepository

 Title        : MergeInPrivateRepository
 Prerequisite : 
 Function     : Save the modification in workspace repository
 Args         : none
 
=cut
sub MergeInPrivateRepository
{
	#&Trace();
	if ($O_PARAM_WB->IsDefined('button_valid'))
	{
		my $session=$RH_WEBBUILDER->GetSessionPath();
		my $cmd="rm -rf $session/db";
		system $cmd;
		$cmd = "cp -a -R ".$O_AUTH->GetWorkspace()."/db $session/db";
		system $cmd;
		my $cfgFile=&MakeCfg($O_PARAM_CGI->Get('cgi_param_learn_cfg'),$DIR_WORKSPACE,$session, $O_PARAM_CGI->Get('cgi_mask_cfg_release'), $O_PARAM_CGI->Get('cgi_mask_cfg_old_release'), "Merge");
		my $cde=$O_PARAM_CGI->Get('cgi_prg_learn_merge_family')." --cfg $cfgFile ".$O_PARAM_CGI->Get('cgi_param_learn') ." --families '".$O_PARAM_WB->Get('families')."' --copy "; 
		#print $cde;
		`$cde`;
		my $cmd="rm -rf $session/*";
		system $cmd;
	}
	&PrintBrowseFamilies();
	
}

=head2 procedure PrintBrowseRnas

 Title        : PrintBrowseRnas
 Prerequisite : none
 Function     : Print the list of rna in $DIR_WORKINGSPACE, propose to delete rna if it's a private workspace.
 
=cut

sub PrintBrowseRnas
{
	my $workspace=$O_PARAM_WB->Get('__wb_workspace') ;
	if ($O_AUTH->IsPrivilege('annotator')  )
	{
		&SelectWorkspace($O_PARAM_WB->Get('__wb_main_menu'),$O_PARAM_WB->Get('__wb_function') );
	}

	my $xml_dir=$DIR_WORKSPACE."/".$O_PARAM_CGI->Get('cgi_dir_rnaml_rna');
	my $result=$RH_WEBBUILDER->GetSessionPath()."/ViewingRnas".$O_AUTH->GetPrivilege().".xhtml";
	if (!-e $result || -z $result || ($workspace eq "private") )
	{ # Command : extraction des donn�es
		my $url = $RH_WEBBUILDER->GetUrl('__wb_function');
		my $param="--stringparam link_genbank '".$O_PARAM_CGI->Get('cgi_link_genbank')."' --stringparam url '".$url."' --stringparam fnt_family DisplayFamily --stringparam fnt_rna DisplayRna ";
		my $cmd = "find $xml_dir -name \"*.xml\" -exec ".$O_PARAM_CGI->Get('cgi_prg_xsl')." $param $cgi_dir_xsl/".$O_PARAM_CGI->Get('cgi_xsl_print_rnas') ." \'{}\' \\;  > $result";
		# voir si on redirige dans result ou pas!
		#print $cmd;
 
		`$cmd`;
	}

	print '<h1 class="learn">RNA Browser</h1>';
	if (-e $result &&  ! -z $result)
	{
		print '<center><label class="labelExample">* Id is computed </label>';
		print '<table class="presentation">	<tbody>	<tr class="head">
		<th></th><th>RNA acc</th><th>Dbxref</th><th>Id*</th><th>Genbank</th><th>Start</th><th>End</th><th></th><th>Program</th><th>Free energy</th><th>Family</th>
		</tr>';
		&DisplayResult($result, "numbering");
		print '</tbody></table></center>	';
	}
	else
	{
		print '<p class="error">No result</p>';
	}
	
}

=head2 procedure DisplayRna

 Title        : DisplayRna
 Prerequisite : none
 Function     : Print the detail of a Rna. 
 
=cut

sub DisplayRna
{	
	my $workspace=$O_PARAM_WB->Get('__wb_workspace') ;
	if ($workspace eq "session" )
	{
		$DIR_WORKSPACE=$RH_WEBBUILDER->GetSessionPath();
	}
	# Command : extraction des donn�es
	my $rna_id=$O_PARAM_WB->Get('RnaDisplay');	
	my $rna_file=$DIR_WORKSPACE."/".$O_PARAM_CGI->Get('cgi_dir_rnaml_rna')."/".$rna_id.$Var::E_XML;
	my $url=$RH_WEBBUILDER->GetUrl('__wb_function');
	my $nb_sub_car=$O_PARAM_CGI->Get('cgi_param_substr');
	my $download_file=substr($rna_file,$nb_sub_car-1);
	
	print '<h1 class="learn">RNA view</h1>';
	print '<p class="text">	<a href="'.$download_file.'" class="button" target=new> Rnaml </a>  </p>';
	
	my $cgi_annot=$O_PARAM_CGI->Get('cgi_url')."/".$O_PARAM_CGI->Get('cgi_file_view_annotation');
	$RH_WEBBUILDER->UnsetBehaviour('encoded_url');
	$cgi_annot.="?".$RH_WEBBUILDER->GetParameters('__wb_function',"&SessionPath=".$RH_WEBBUILDER->GetSessionPath());
	my $url_annot=$url;
	my $cgi=$RH_WEBBUILDER->GetCgi();
	my $result=$RH_WEBBUILDER->GetSessionPath()."/DisplayRna.xhtml";
	my $param='--stringparam link_rfam "'.$O_PARAM_CGI->Get('cgi_link_rfam').'" --stringparam link_genbank "'.$O_PARAM_CGI->Get('cgi_link_genbank').'" --stringparam index_car_substr_img '.$nb_sub_car.'  --stringparam url "'.$url.'" --stringparam fnt_family DisplayFamily  --stringparam url_annot "'.$cgi_annot.'"';
	my $cmd = $O_PARAM_CGI->Get('cgi_prg_xsl')." $param $cgi_dir_xsl/".$O_PARAM_CGI->Get('cgi_xsl_print_rna') ."  $rna_file > $result";
	#print $cmd;
	`$cmd`;
	&DisplayResult($result);

	if ($workspace eq "private" )
	{
		my $string_inputs='
				<center>
					<INPUT type="submit" value="Edit" class="button" >
					<INPUT name="RnaEdit" value="'.$rna_id.'" type="hidden" />
					<INPUT name="__wb_rna_definition_validated" value="0" type="hidden" />
				</center>';
		# en post  il faut faire passer tout les parametres / test effectuer avec action contenant cgi + les valeurs inchang�es(ne fonctionne pas)
		&PrintForm($O_PARAM_WB->Get('__wb_main_menu'), "EditRna",$string_inputs);
	}
	
}


=head2 procedure EncodeAccent

 Title        : EncodeAccent
 Prerequisite : none
 Function     : Convert all letters with accent, without accent.	
 		and encode data like > in html format.
 Args         : $string to convert
 
=cut

sub EncodeAccent
{
	my $string = shift;
	$string =~ tr/��������������������������/aaaAAeeeeEEiiIIooOOuuuUUyY/;
	encode_entities($string);
	return $string;
}

=head2 procedure EditRna

 Title        : EditRna
 Prerequisite : RnaEdit of RH_PARAM is set.
 Function     : Treat data comes from form, load object and call function to print adequate form
 Args         : none
 
=cut

sub EditRna
{
	
	my $rna_id=$O_PARAM_WB->Get('RnaEdit');
	#&Trace;
	# FERME LE FLUX
	my ($oldout, $olderr) = &CloseStd();
		
	my $application;
	# clic dans la fenetre
	my @a_keys=$O_PARAM_WB->GetKeys("button");
	my $clic=$#a_keys;
	my $msg_err= "";
	
	if ($O_PARAM_WB->IsDefined('button_reset_rna'))
	{
		$O_PARAM_WB->Set('__wb_bounds_changed',0)
		&ClearSessionPath();
		$clic=-1;
		$O_PARAM_WB->Set('__wb_rna_definition_validated',0);
		$O_PARAM_WB->Set('__wb_rna_annotation_validated',0);
	}
	
	# Chargement de l'ARN et/ou de la famille
	if (($O_PARAM_WB->Get('__wb_rna_definition_validated') && 	
		$O_PARAM_WB->Get('__wb_bounds_changed') )
	   && 
	   ($O_PARAM_WB->IsDefined('button_valid_annotation') || $O_PARAM_WB->Get('__wb_rna_annotation_validated') ) )
	{	# si on a valid� l'annotation et que les bornes ont �t� modifi�
		# si on veux valider et que l'on a modifier  les bornes on chrge la famille
		
		$application=&LoadRnaObject( $rna_id, $O_PARAM_CGI->Get('cgi_param_learn_cfg'), $RH_WEBBUILDER->GetSessionPath(), $DIR_WORKSPACE,$O_PARAM_CGI->Get('cgi_mask_cfg_release'), $O_PARAM_CGI->Get('cgi_mask_cfg_old_release'),$clic,"EditRna" , $O_PARAM_WB->Get('Family'));
	}
	else
	{
		# chargement de l'arn uniquement
		$application=&LoadRnaObject( $rna_id,  $O_PARAM_CGI->Get('cgi_param_learn_cfg'), $RH_WEBBUILDER->GetSessionPath(), $DIR_WORKSPACE , $O_PARAM_CGI->Get('cgi_mask_cfg_release'), $O_PARAM_CGI->Get('cgi_mask_cfg_old_release'),$clic,"EditRna");
	}
	
	# toutes les sequences creees n'ont pas de path !!! on le fixe :
	foreach my $key_seq (keys %{$application->{'__h_sequence'}})
	{
		$application->{'__h_sequence'}{$key_seq}->SetPathOfSeqFile($O_PARAM_CGI->Get('dir_learn')."/".$O_PARAM_CGI->Get('cgi_dir_release')."/".$application->{'__o_param'}->Get('path_source_sequence'));
	}
	
	my $o_rna=$application->GetRna($rna_id);
	my $path_img=$o_rna->GetStructure()->GetImage();
	#path/img/AC1520232_r2_1.jpg ou path/img/AC1520232_r2.jpg
	my @img=split(/[_.]/,$path_img);
	if ($img[$#img-1] !~ /^r/)
	{
		$img[$#img-1]++;
		# supprime l'extention
		splice (@img, $#img,1);
	}
	else
	{
		$img[$#img]=0;
	}
	my $new_path_img=join("_",@img);
	$new_path_img.=$Var::E_IMG;
	my $cmd="cp $path_img $new_path_img";
	
	system $cmd;
	$o_rna->GetStructure()->SetImage($new_path_img);

	 
	#si on a clique un button et que l'on a pas valide la definition
	if ((!$O_PARAM_WB->Get('__wb_rna_definition_validated') || $O_PARAM_WB->IsDefined('button_valid_definition') )
	&& $clic>-1)	
	{ # on recup�re toutes les informations du formulaire de definition.
	
		$o_rna->SetDesc(&EncodeAccent($O_PARAM_WB->Get('input_desc'))) if ($O_PARAM_WB->IsDefined('input_desc'));
		$o_rna->SetStatus($O_PARAM_CGI->Get('cgi_status_'.$O_PARAM_WB->Get('input_status')) )  if ($O_PARAM_WB->IsDefined('input_status')) ;
		$o_rna->SetName(&EncodeAccent($O_PARAM_WB->Get('input_name'))) if ($O_PARAM_WB->IsDefined('input_name')) ;
		$o_rna->SetDbxref(&EncodeAccent($O_PARAM_WB->Get('input_dbxref'))) if ($O_PARAM_WB->IsDefined('input_dbxref')) ;
		$o_rna->SetLastUpd($application->{'__today'});
		
		$msg_err=&InitRnaBounds(\$o_rna,$O_PARAM_WB->Get('input_seq_start'),$O_PARAM_WB->Get('input_seq_end')); 
		
		if ($O_PARAM_WB->Get('button_upload') eq "Update SeqData")
		{	#modification des bornes (et chargement de seq data fait precedement)
			
			# variable utilis� pour savoir si les bornes on changer et si on doit visualis� la famille modifi�.
			$O_PARAM_WB->Set('__wb_bounds_changed',1);
			
			# les annotation sont obsoletes ==> on les supprime
			$o_rna->{'__a_annotate'}=();
		}
		
		
		if (($O_PARAM_WB->Get('button_upload_struct') eq "Update secondary structure") 
		&& ($O_PARAM_WB->Get('input_struct') ne "") )
		{ # pour notre propre structure saisie
			
			my $okou = $o_rna->GetStructure()->GetStructure();
			my $struct=$O_PARAM_WB->Get('input_struct');
			chomp($struct);
			$struct=~s/[\r\n|\s|\<br\>|\t]*//g;
			$o_rna->GetPrincipalRange()->ComputeLength();
			my $seq_lg=$o_rna->GetPrincipalRange()->GetLength();
			
			if ( $seq_lg == length($struct))
			{
				$o_rna->GetStructure()->SetStructure($struct);
				$o_rna->ComputePlotEval($o_rna->GetSequence());
				#$o_rna->SetProgForStructure(&Learn::GetRefProgram('R_PLOT_EVAL', "actual"));
				#$o_rna->ComputeStructure();
				$O_PARAM_WB->Set('__wb_not_fold',1);
				if ( $o_rna->GetStructure()->GetStructure() eq '' )
				{
					$o_rna->GetStructure()->SetStructure($okou);
					$o_rna->ComputePlotEval($o_rna->GetSequence());
					$msg_err= '<p class="error">Error: unable to update the structure, brackets must be balanced</p>';
				}
			}
			else
			{
				$msg_err= '<p class="error">Error: sequence and structure have different length : sequence length='.$seq_lg.', structure length='.  length($struct).'</p>';
				
			}
		}
		# recalcul de la structure si demande de fold ou si les bornes ont chang�.
		elsif (
		($O_PARAM_WB->Get('button_fold') eq "Folding prediction" ) ||   
		($O_PARAM_WB->Get('button_upload') eq "Update SeqData") )
		{	
			$o_rna->SetProgForStructure(&Learn::GetRefProgram($O_PARAM_WB->Get('input_fold_prg'), "actual"));
			$o_rna->ComputeStructure();
			if ( $O_PARAM_WB->Get('input_fold_prg') eq 'R_FOLD' )	# sinon mfold ne permet pas la mise a jour de l'image 
																	# il faudrait plutot le faire dans  SecondaryStructure
			{
				$o_rna->ComputePlotEval($o_rna->GetSequence());
			}
			$O_PARAM_WB->Set('__wb_not_fold',0);
		}
	}
	else # Formulaire d'annotation
	{	
		if ($O_PARAM_WB->IsDefined('button_add_annot') )
		{
			
			my $annot_start=$O_PARAM_WB->Get('annot_start');
			my $annot_end=$O_PARAM_WB->Get('annot_end');
			if ( $annot_start ne '' && $annot_end ne '' && ($annot_start <= $annot_end) && ($annot_end <= $o_rna->GetPrincipalRange()->GetLength() ) )
			{	
				$O_PARAM_WB->SelectNameSpace('annot_');
				$o_rna->AddNewAnnotate($annot_start,$annot_end,&EncodeAccent($O_PARAM_WB->Get('title')),&EncodeAccent($O_PARAM_WB->Get('comment')), $O_AUTH->GetLogin(), time());
				$O_PARAM_WB->SelectNameSpace();
			}
			else
			{
				
				$msg_err= '<p class="error">Error on annotation boundaries</p>';
			}
		}
		else
		{
			
			my @a_del=$O_PARAM_WB->GetKeys('button_annot_del_') ;
			if ($#a_del > -1)
			{
				
				my @a_tmp=split(/_/,$a_del[0]);
				my $stamp=$O_PARAM_WB->Get('annot_del_'.$a_tmp[$#a_tmp]);
				$o_rna->DeleteAnnotate( $o_rna->GetIndexFromTimeStamp($stamp) );
			}
		}
	}
	
	# si on a valid� la definition/annotation on initialise la variable wb.
	if ($O_PARAM_WB->IsDefined('button_valid_definition'))
	{
		$O_PARAM_WB->Set('__wb_rna_definition_validated',1);
	}
	if ($O_PARAM_WB->IsDefined('button_valid_annotation'))
	{	
		$O_PARAM_WB->Set('__wb_rna_annotation_validated',1);
	}
	
	&OpenStd($oldout, $olderr) ;
	
	if ( $msg_err ne "")
	{
		print $msg_err;
	}
	
	# si on a pas valide la definition 
	if ($O_PARAM_WB->Get('__wb_rna_definition_validated') != 1 )
	{
		# formulaire de definition
		print ' <h1 class="learn">RNA Annotation 1 : Structure definition</h1>';
		&PrintFormRnaDefinition($application, $rna_id);
		# information sur l'annotation
		if ($o_rna->GetNbAnnotations() >-1 )
		{
			print '<h2 class="learn">Annotations : </h2>' ;
			print '<div class="div_learn">';
			&PrintInformationRnaAnnotation($o_rna);
			print '</div>';
		}
		 
		my $string_inputs='<INPUT name="RnaEdit" value="'.$rna_id.'" type="hidden" />
		<INPUT name="Family" value="'.$o_rna->GetFamilyAcc().'" type="hidden" />
		<INPUT name="__wb_bounds_changed" value="'.$O_PARAM_WB->Get('__wb_bounds_changed').'" type="hidden" />
		<INPUT name="__wb_not_fold" value="'.$O_PARAM_WB->Get('__wb_not_fold').'" type="hidden" />
		<center>
		<INPUT name="button_reset_rna" type="submit" value="Reset rna" class="button" >
		<INPUT name="button_valid_definition" type="submit" value="Validation of structural annotation of '.$rna_id.'" class="button" > </center><br />';
		&PrintForm($O_PARAM_WB->Get('__wb_main_menu'), "EditRna",$string_inputs,"noaction");
		
	}
	else
	{
		
		my $string_inputs;

		if (  $O_PARAM_WB->IsDefined('button_valid_annotation') || $O_PARAM_WB->IsDefined('button_valid') )
		{
			my $session_space=$RH_WEBBUILDER->GetSessionPath();
			my $path_img=$session_space."/".$application->{'__o_param'}->Get('path_db_learn_rna_img')."/$rna_id$Var::E_IMG";
			my $cmd="cp $new_path_img $path_img";
			system $cmd;
			$o_rna->GetStructure()->SetImage($path_img);
			if (  $O_PARAM_WB->IsDefined('__wb_bounds_changed') &&  $O_PARAM_WB->Get('__wb_bounds_changed')== 1 )
			{	
				&EditRnaViewFamily($application,$rna_id, $O_PARAM_WB->Get('Family'));
			}
			else
			{
			# si on valide et que les bornes ont pas change ->Sauve le xml et l'image
				
				# fichire image
				$cmd="cp $session_space/".$application->{'__o_param'}->Get('path_db_learn_rna_img')."/$rna_id.* $DIR_WORKSPACE/".$application->{'__o_param'}->Get('path_db_learn_rna_img');
				system $cmd;
				# fichier ss
				$cmd="cp $session_space/".$application->{'__o_param'}->Get('path_db_learn_rna_ss')."/$rna_id.* $DIR_WORKSPACE/".$application->{'__o_param'}->Get('path_db_learn_rna_ss');
				system $cmd;
				
				# on remodifie les path des fichier associer � l'arn 
				$o_rna->GetStructure()->SetPathsSS($DIR_WORKSPACE."/".$application->{'__o_param'}->Get('path_db_learn_rna_ss'));
				
				$o_rna->GetStructure()->SetPathImg($DIR_WORKSPACE."/".$application->{'__o_param'}->Get('path_db_learn_rna_img'));
				$o_rna->SaveRnaml($DIR_WORKSPACE."/".$O_PARAM_CGI->Get('cgi_dir_rnaml_rna'), $DIR_WORKSPACE."/".$application->{'__o_param'}->Get('path_db_learn_rna_tmp'));
				$O_PARAM_WB->Set('RnaDisplay',$rna_id);
				$cmd="rm -rf $session_space/".$application->{'__o_param'}->Get('path_db');
				#system $cmd;
				&DisplayRna();
			}
		}
		else
		# ( $O_PARAM_WB->Get('__wb_rna_definition_validated') && not $O_PARAM_WB->IsDefined('button_valid_annotation'))
		{
			print ' <h1 class="learn">RNA Annotation 2 : Segment annotation</h1>';
			&PrintInformationRnaDefinition($application, $rna_id);
			#<FORM action="'.$RH_WEBBUILDER->GetCgi().'" name="FormRnaDefinition" method="post">';
			print '<h2 class="learn">Annotations : </h2>
			<div class="div_learn">';
			
			&PrintInformationRnaAnnotation($application->GetRna($rna_id), "Form");
			&PrintFormRnaAnnotation();
			print "</div>";
			$string_inputs='<INPUT name="RnaEdit" value="'.$rna_id.'" type="hidden" />
			<INPUT name="__wb_rna_definition_validated" value="'.$O_PARAM_WB->Get('__wb_rna_definition_validated').'" type="hidden" />
			<INPUT name="__wb_bounds_changed" value="'.$O_PARAM_WB->Get('__wb_bounds_changed').'" type="hidden" />
			<INPUT name="Family" value="'.$o_rna->GetFamilyAcc().'" type="hidden" />';
			
			print '<center><INPUT name="button_reset_rna" type="submit" value="Reset rna" class="button" >';
			if ( $O_PARAM_WB->Get('__wb_bounds_changed')== 0 )
			{
				print '<INPUT name="button_valid_annotation" type="submit" value="Validate '.$rna_id.' in '.$O_AUTH->GetLogin().' workspace" class="button" >';
			}
			else
			{
				print '<INPUT name="button_valid_annotation" type="submit" value="View family updated" class="button" > ';
			}
			print '</center><br />';
			&PrintForm($O_PARAM_WB->Get('__wb_main_menu'), "EditRna",$string_inputs,"noaction");
		}
		
		
	}
	$o_rna->SaveRnaml($RH_WEBBUILDER->GetSessionPath()."/".$O_PARAM_CGI->Get('cgi_dir_rnaml_rna'), $RH_WEBBUILDER->GetSessionPath()."/".$application->{'__o_param'}->Get('path_db_learn_rna_tmp'));
	
}

=head2 procedure PrintFormRnaDefinition

 Title        : PrintFormRnaDefinition
 Prerequisite : rna loaded
 Function     : Print a from with data of rna object from the application.
 Args         : $application :a LeARN application containing data from rna
 		$id_rna : id of the rna wich is editing.

=cut

sub PrintFormRnaDefinition
{
	my ($application, $id_rna) =@_;
	my $o_rna=$application->GetRna($id_rna);
	my $seq=${$o_rna->GetPrincipalRange()->GetSequence()};
	
	print ' <h1 class="learn">'.$o_rna->GetId().'</h1>
	<FORM action="'.$RH_WEBBUILDER->GetCgi().'" name="FormRnaDefinition" method="post">
	
	<h2 class="learn">Sequence : </h2>';
	print '<div class="div_learn"> <table>
	<tbody><tr>
			<td><label class="text1">Id:</label></td>
			<td><INPUT type="text" name="input_name" class="saisie_seq" value="'.$o_rna->GetName().'"></td>
			<td><label class="text1">Organism:</label></td>
			<td><i>'.$seq->GetOrganism().'</i></td>
		</tr>';
	my $comment = $o_rna->GetDesc();
	$comment =~ s/;/,/g;
	print ' <tr>
			<td><label class="text1">Comment:</label></td>
			<td><INPUT type="text" name="input_desc" class="saisie_seq" value="'.$comment.'"></td>
			<td><label class="text1">LeARN family: </label></td>
			<td>'.$o_rna->GetFamilyAcc().'</td>
			
		</tr>';
	print ' <tr>
			<td><label class="text1">Dbxref:</label></td>
			<td><INPUT type="text" name="input_dbxref" class="saisie_seq" value="'.$o_rna->GetDbxref().'"></td>
			<td><label class="text1">Last updated:</label></td>
			<td>'.$o_rna->GetLastUpd().'</td>
		</tr>
		<tr>
			<td><label class="text1">Status:</label></td>
			<td>
				<select NAME="input_status">';
				foreach my $key ($O_PARAM_CGI->GetKeys("cgi_status_"))
				{
					my $sub_key=$key;
					$sub_key=~s/cgi_status_//;
					if ($key ne "")
					{
						print '<option VALUE="'.$sub_key.'"';
						my $value = $O_PARAM_CGI->Get($key);
						print ' selected ' if ($o_rna->GetStatus() =~ /$value/i);
						print '>'.$value.'</option>';
					}
				}
				print '</select>
			</td>
			<td><label class="text1">Length: </label></td>
			<td>'.$o_rna->GetLength().'</td>
		</tr>';

	print ' <tr>
			<td>
			<label class="text1"></label>
			<a href="'.$O_PARAM_CGI->Get('cgi_link_genbank').'&val='.$seq->GetId().'" target=new>'.$seq->GetId().'</a>
			</td>
			<td>
				<INPUT type="text" name="input_seq_start" class="saisie_num" value='.$o_rna->GetPrincipalRange()->GetStart().'> - 
				<INPUT type="text" name="input_seq_end" class="saisie_num" value='.$o_rna->GetPrincipalRange()->GetEnd().'> 
				('.$o_rna->GetPrincipalRange()->GetStrand().') 
				<INPUT type="submit" name="button_upload" value="Update SeqData" class="button">
			</td>
			<td>	<label class="text1">Detected by:</label></td>
			<td>'.${$o_rna->GetPrincipalRange()->GetProgDetect()}->GetName().'</td>
		</tr>';

	print ' <tr>
			<td><label class="text1">SeqData:</label></td>
			<td>
			<table><tr><td></td>
			<td>
			<label class="seq_data">&gt;'.$o_rna->GetId().'</label>
			</td>
			</tr>';
			my $seq_data=$o_rna->GetPrincipalRange()->GetSeqData();
			my $new_seq_data="";
			my $i=0;
			
			while ( $i < length($seq_data))
			{
				$new_seq_data=substr($seq_data,$i,50)." ";
				my $value=$i+1;
				print '<tr><td><label class="number">'.$value .'</label></td>
				<td><label class="seq_data">'.$new_seq_data.' </label></td></tr>';
				$i+=50;
				
			}
			print '</table></td>
			<td></td>
			<td></td>
		</tr>
	</tbody>
	</table>
	</div>';
	
	print '
	<h2 class="learn">Structure : </h2>
	<div class="div_learn">
	<table >
	<tbody>
	<tr>
	<td valign="top">
		<label class="text1">Structure computed by:</label>
		'.${$o_rna->GetProgForStructure()}->GetName().'
		<label class="text2">Free-energie:</label>
		'.$o_rna->GetStructure()->GetFreeEnergy().' <br />
			<label class="text1">Parenthesis structure :</label>
			';
			if (defined($o_rna->GetStructure()->GetStructure()) && ! -e $o_rna->GetStructure()->GetStructure())
			{
					print '<pre>';
					my $seq_data=$o_rna->GetStructure()->GetStructure();
					my $new_seq_data="";
					my $i=0;
					while ( $i < length($seq_data))
					{
						$new_seq_data=substr($seq_data,$i,50);
						print "$new_seq_data<br />";
						$i+=50;
					}
					print '</pre>';
	
			}
			print '
				<label class="text1">Enter your parenthesis structure :</label>
				<br />
				<textarea name="input_struct" rows="5" class="saisie_seq"></textarea>
				<br />
				<INPUT type="submit" name="button_upload_struct" value="Update secondary structure" class="button">
			';
			
			print '
	</td>
	<td>
		<p class="node"><img src="'.substr($o_rna->GetStructure()->GetImage(),$O_PARAM_CGI->Get('cgi_param_substr')-1).'" class="ss"></p>
			<label class="text1">Program :</label>
			<select NAME="input_fold_prg" >';
			my $prog_name=${$o_rna->GetProgForStructure()}->GetName();
			my @a_typ=split(' ', $Learn::H_PROG_TYPE{$prog_name});
			
			foreach my $key (@a_typ)
			{	
				if (defined($Learn::H_PROGRAM_ACTUAL{$key}))
				{
					print '<option VALUE="'.$key.'"';
					my $value = $Learn::H_PROGRAM_ACTUAL{$key}->GetName();
					print ' selected ' if (${$o_rna->GetProgForStructure()}->GetName() =~ /$value/i);
					print '>'.$value.'</option>';
				}
			}
			
		print '</select>
		<INPUT type="submit" name="button_fold" value="Folding prediction" class="button" > 
		
	</td>
	</tr>
	</tbody>
	</table>
	</div>

	<br />
';

}

=head2 procedure PrintInformationRnaDefinition

 Title        : PrintInformationRnaDefinition
 Prerequisite : rna loaded
 Function     : Print a information with data of rna object from the application.
 Args         : $application :a LeARN application containing data from rna
 		$id_rna : id of the rna wich is editing.

=cut
 
sub PrintInformationRnaDefinition
{
	my ($application, $id_rna) =@_;
	my $o_rna=$application->GetRna($id_rna);
	my $seq=${$o_rna->GetPrincipalRange()->GetSequence()};
	print ' <h1 class="learn">'.$o_rna->GetId().'</h1>
	<h2 class="learn">Sequence: </h2>';
	print ' <div class="div_learn"><table>
	<tbody><tr>
			<td><label class="text1">Id:</label></td>
			<td>'.$o_rna->GetName().'</td>
			<td><label class="text1">Organism:</label></td>
			<td><i>'.$seq->GetOrganism().'</i></td>
		</tr>';
	print ' <tr>
			<td><label class="text1">Comment:</label></td>
			<td>'.$o_rna->GetDesc().'</td>
			
			<td><label class="text1">LeARN family: </label></td>
			<td>'.$o_rna->GetFamilyAcc().'</td>
		</tr>';
	print ' <tr>
			<td><label class="text1">Dbxref:</label></td>
			<td>'.$o_rna->GetDbxref().'</td>
			<td><label class="text1">Last updated:</label></td>
			<td>'.$o_rna->GetLastUpd().'</td>
		</tr>';
	print ' <tr>
			<td><label class="text1">Status:</label></td>
			<td>
				'.$o_rna->GetStatus().'
			</td>
			<td><label class="text1">Length: </label></td>
			<td>'.$o_rna->GetLength().'</td>
		
			
		</tr>';
	print ' <tr>
			<td>
			<label class="text1"></label> 
			<a href="'.$O_PARAM_CGI->Get('cgi_link_genbank').'&val='.$seq->GetId().'" target=new>'.$seq->GetId().'</a>
			</td>
			<td>
				'.$o_rna->GetPrincipalRange()->GetStart().' -
				'.$o_rna->GetPrincipalRange()->GetEnd().'
				('.$o_rna->GetPrincipalRange()->GetStrand().') 
			</td>
			<td>	<label class="text1">Detected by:</label></td>
			<td>'.${$o_rna->GetPrincipalRange()->GetProgDetect()}->GetName().'</td>
		</tr>
		</tbody>
	</table>';
	
	
	print ' 
			<label class="text1">SeqData:</label>
			
			<table><tr><td></td>
			<td>
			<label class="seq_data">&gt;'.$o_rna->GetId().'</label>
			</td>
			</tr>';
			my $seq_data=$o_rna->GetPrincipalRange()->GetSeqData();
			my $new_seq_data="";
			my $i=0;
			
			while ( $i < length($seq_data))
			{
				$new_seq_data=substr($seq_data,$i,50)." ";
				my $value=$i+1;
				print '<tr><td><label class="number">'.$value .'</label></td>
				<td><label class="seq_data">'.$new_seq_data.' </label></td></tr>';
				$i+=50;
				
			}
			print '</table>
		
	
	</div>';
	print '
	<h2 class="learn">Structure : </h2>
	<div class="div_learn">
	<table >
	<tbody>
	<tr valign="top">
	<td>
		<label class="text1">Structure computed by:</label>
		'.${$o_rna->GetProgForStructure()}->GetName().' <br />
		<label class="text1">Free-energie:</label>
		'.$o_rna->GetStructure()->GetFreeEnergy().'<br /><br />
		
			<label class="text1">Parenthesis structure :</label><br />
			';
			if (defined($o_rna->GetStructure()->GetStructure()) && ! -e $o_rna->GetStructure()->GetStructure())
			{
					print '<pre>';
					my $seq_data=$o_rna->GetStructure()->GetStructure();
					my $new_seq_data="";
					my $i=0;
					while ( $i < length($seq_data))
					{
						$new_seq_data=substr($seq_data,$i,50);
						print "$new_seq_data<br />";
						$i+=50;
					}
					print '</pre>';
			}
			print '
	</td>
	<td>
		<table>
		<tbody>
			
			<p class="node"><img src="'.substr($o_rna->GetStructure()->GetImage(),$O_PARAM_CGI->Get('cgi_param_substr')-1).'" class="ss"></p>
		</tbody>
		</table>
	</td>
	</tr>
	</tbody>
	</table>
	</div>
	<br />';
}

=head2 procedure InitRnaBounds

 Title        : InitRnaBounds
 Prerequisite : rna loaded
 Function     : Valid bound and init rna object
		bound must at least overlap old data, start < end, and length not to long.
 Args         : $ro_rna : reference on rna object
 		$in_start : start from form
 		$in_end   : end from form

=cut

sub InitRnaBounds
{
	my ($ro_rna, $in_start, $in_end) = @_;
	
	my $old_start=$$ro_rna->GetPrincipalRange()->GetStart();
	my $old_end=$$ro_rna->GetPrincipalRange()->GetEnd();
	if ($in_start !~ /^\d+$/ || $in_end !~ /^\d+$/ )
	{
		return '<p class="error">Error on RNA boundaries: numbers are expected</p>';
	}
	if (($in_start < $in_end) &&
		(( $in_start >= $old_start and $in_start <= $old_end ) or
		( $in_end   >= $old_start and $in_end <= $old_end ) or
		( $in_start <= $old_start and $in_end >= $old_end ) )
		&& ( ($in_end-$in_start) < $O_PARAM_CGI->Get('cgi_param_max_sequence_size') ) )
	{		 
		$$ro_rna->GetPrincipalRange()->SetStart($in_start);
		$$ro_rna->GetPrincipalRange()->SetEnd($in_end);
		${$$ro_rna->GetPrincipalRange()->GetSequence()}->SetSequence();
		$$ro_rna->GetPrincipalRange()->ComputeSeqData();
		${$$ro_rna->GetPrincipalRange()->GetSequence()}->UnsetSequence();
	}
	else
	{
		return '<p class="error">Error on RNA boundaries: start and/or end position [$in_start-$in_end] are out of range [$old_start-$old_end]</p>';
	}
	# return 1 if bound changed / 0 sinon

}


=head2 procedure PrintFormRnaAnnotation

 Title        : PrintFormRnaAnnotation
 Prerequisite : none
 Function     : Print a form to enter an annotation
 Args         : none

=cut

sub PrintFormRnaAnnotation
{
	
	print '
	
	<FORM action="'.$RH_WEBBUILDER->GetCgi().'" name="FormRnaAnnotation" method="post">
	<p class="node">
	<table>
	<tbody>
	<tr>
		<td>
			<label class="text1"> Description : <label> 
		</td>
		<td>
			<INPUT type="text" name="annot_title" class="saisie_seq" >
		</td>
		<td>
			<label class="text1">Boundaries : <label> 
		</td>
		<td>
			<INPUT type="text" name="annot_start" class="saisie_num">
			<INPUT type="text" name="annot_end" class="saisie_num" >
		</td>
	</tr>
	<tr>
	<td>
		<label class="text1"> Comment : <label>
	</td>
	<td>
		<textarea name="annot_comment" rows="3" class="saisie_seq"></textarea>
	</td>
	<td>
	</td>
	<td>
		<INPUT name="button_add_annot" type="submit" value="Add annotation" class="button" >
	</td>
	</tr>
	</tbody>
	</table>
	';
}


=head2 procedure PrintInformationRnaAnnotation

 Title        : PrintInformationRnaAnnotation
 Prerequisite : rna object loaded
 Function     : Print all the annotation of an rna.
 		propose to plot this annotation (call a new cgi) 
 		and delete if form is defined
 Args         : $o_rna :rna object with annotation 
 		$form : to determine if you can delete annotation or not.

=cut

sub PrintInformationRnaAnnotation
{
	my ($o_rna, $form)=(@_);
	my $nb_annot=$o_rna->GetNbAnnotations();
	if ($nb_annot>=0)
	{	my $cgi=$RH_WEBBUILDER->GetCgi();
		my $cgi_annot=$O_PARAM_CGI->Get('cgi_url')."/".$O_PARAM_CGI->Get('cgi_file_view_annotation');
		#my $url_annot=$RH_WEBBUILDER->GetUrl('__wb_function');
		$RH_WEBBUILDER->UnsetBehaviour('encoded_url');
		$cgi_annot.="?".$RH_WEBBUILDER->GetParameters('__wb_function',"&SessionPath=".$RH_WEBBUILDER->GetSessionPath());
		print '
		<ul>';
		
		for (my $i=0; $i <= $nb_annot; $i++)
		{
			 print '<li><table><tr><td>
			  '. $o_rna->GetAnnotate($i)->GetStart().
			 ' - ' . $o_rna->GetAnnotate($i)->GetEnd(). ' 
				</td><td><a class="button" href="'.$cgi_annot.'&RnaDisplay='.$o_rna->GetId().'&Start='.$o_rna->GetAnnotate($i)->GetStart().'&End='.$o_rna->GetAnnotate($i)->GetEnd().'&Title='.$o_rna->GetAnnotate($i)->GetTitle().'" target="new" >Plot</a> </td>';
			 if (defined( $form))
			 {
			 	my $input_string='<td><INPUT name="button_annot_del_'.$i.'" type="submit" value="Del" class="button" >
			 	<INPUT name="annot_del_'.$i.'" type="hidden" value="'.$o_rna->GetAnnotate($i)->GetTimeStamp().'">
			 	<INPUT name="RnaEdit" value="'.$o_rna->GetId().'" type="hidden" />
				<INPUT name="__wb_rna_definition_validated" value="'.$O_PARAM_WB->Get('__wb_rna_definition_validated').'" type="hidden" />
				<INPUT name="__wb_bounds_changed" value="'.$O_PARAM_WB->Get('__wb_bounds_changed').'" type="hidden" />
				<INPUT name="Family" value="'.$o_rna->GetFamilyAcc().'" type="hidden" />';
			 	&PrintForm($O_PARAM_WB->Get('__wb_main_menu'), "EditRna",$input_string);
			 	print '</td>';
			 }
			 print '</tr></table>'; # une table pour que button del et plot soient sur la mm ligne
			 print '
			 <ul> 
				<li> Description: '.$o_rna->GetAnnotate($i)->GetTitle().'</li>
				<li> Login: ' .$o_rna->GetAnnotate($i)->GetLogin() .' </li> 
				<li> Created: ' . TimeStampToString($o_rna->GetAnnotate($i)->GetTimeStamp()).'</li>
				<li> Comment: ' .$o_rna->GetAnnotate($i)->GetLegend() .'</li>
			 </ul><br />';
			 #<li> Created: ' .$o_rna->GetAnnotate($i)->GetTimeStamp().'</li>
			 print "</li>"
		}
		print '</ul>';
		if ($nb_annot>1)
		{
			print '<center><a class="button" href="'.$cgi_annot.'&RnaDisplay='.$o_rna->GetId().'" target="new" >Plot all annotations</a></center> ';
		}
		print '<br />';
	
	}
}
sub TimeStampToString
{
	my $time_stamp=shift;
	my ($secondes, $minutes, $heures, $jour_mois, $mois, $an, $jour_semaine, $jour_calendaire, $heure_ete) = localtime($time_stamp);
	$mois+=1;
	$jour_calendaire+=1;
	$mois = $mois < 10 ? $mois = "0".$mois : $mois;
	$jour_mois = $jour_mois < 10 ? $jour_mois = "0".$jour_mois : $jour_mois;
	$heures = $heures < 10 ? $heures = "0".$heures : $heures;
	$minutes = $minutes < 10 ? $minutes = "0".$minutes : $minutes;
	$secondes = $secondes < 10 ? $secondes = "0".$secondes : $secondes;
	$an+=1900;
	my $human_date="$heures:$minutes:$secondes $jour_mois/$mois/$an";
	return ($human_date);
}

=head2 procedure EditRnaViewFamily

 Title        : EditRnaViewFamily
 Prerequisite : rna object loaded
 Function     : Print the family updated by the change of rna boundary.
 Args         : 

=cut

sub EditRnaViewFamily
{
	my ($application,$rna_id, $family_id)=@_;
	my $session_space=$RH_WEBBUILDER->GetSessionPath();
	print ' <h1 class="learn">RNA Annotation 3 : Validation of the updated family  <br /> (due to changes of the RNA boundaries)</h1>' if ($O_PARAM_WB->Get('button_valid_annotation') eq "View family updated");
	# si on valide on copie tout les fichier de la famille et de l'arn dans le DIR_WORKSPACE
	if (($O_PARAM_WB->Get('__wb_rna_definition_validated') eq 1 ) &&  $O_PARAM_WB->Get('__wb_rna_annotation_validated') eq 1
	&& not ($O_PARAM_WB->Get('button_valid_annotation') eq "View family updated"))
	{	
		# Changement des paths de l'image dans la famille:
		my $old_path=$session_space;
		$old_path=~s,/,\\/,g;
		my $new_path=$DIR_WORKSPACE;
		$new_path=~s,/,\\/,g;
		my $cmd_sed='sed -e "s/'.$old_path.'/'.$new_path.'/" ';
		
		#Fichiers xml
		my $cmd=$cmd_sed." $session_space/".$O_PARAM_CGI->Get('cgi_dir_rnaml_family')."/$family_id.xml > $DIR_WORKSPACE/".$O_PARAM_CGI->Get('cgi_dir_rnaml_family')."/$family_id.xml";
		#"cp $session_space/".$O_PARAM_CGI->Get('cgi_dir_rnaml_family')."/$family_id.xml $DIR_WORKSPACE/".$O_PARAM_CGI->Get('cgi_dir_rnaml_family');
		system $cmd;
		
		$cmd=$cmd_sed." $session_space/".$O_PARAM_CGI->Get('cgi_dir_rnaml_rna')."/$rna_id.xml > $DIR_WORKSPACE/".$O_PARAM_CGI->Get('cgi_dir_rnaml_rna')."/$rna_id.xml";
		#$cmd="cp $session_space/".$O_PARAM_CGI->Get('cgi_dir_rnaml_rna')."/$rna_id.xml $DIR_WORKSPACE/".$O_PARAM_CGI->Get('cgi_dir_rnaml_rna');
		system $cmd;
		
		#Fichiers image
		$cmd="cp $session_space/".$application->{'__o_param'}->Get('path_db_learn_family_img')."/$family_id.* $DIR_WORKSPACE/".$application->{'__o_param'}->Get('path_db_learn_family_img');
		system $cmd;
		
		
		$cmd="cp $session_space/".$application->{'__o_param'}->Get('path_db_learn_rna_img')."/$rna_id.* $DIR_WORKSPACE/".$application->{'__o_param'}->Get('path_db_learn_rna_img');
		system $cmd;

		#Fichiers ss
		#$cmd="cp $session_space/".$application->{'__o_param'}->Get('path_db_learn_family_ss')."/$family_id.* $DIR_WORKSPACE/".$application->{'__o_param'}->Get('path_db_learn_family_ss');
		#system $cmd;
		$cmd="cp $session_space/".$application->{'__o_param'}->Get('path_db_learn_rna_ss')."/$rna_id.* $DIR_WORKSPACE/".$application->{'__o_param'}->Get('path_db_learn_rna_ss');
		system $cmd;
		
		# repertoire de la famille dans RFL
		$cmd="cp -r $session_space/".$application->{'__o_param'}->Get('path_db_rfl')."/$family_id $DIR_WORKSPACE/".$application->{'__o_param'}->Get('path_db_rfl');
		system $cmd;
		
		
		
		
		# on va remplacer la s�quence de l'arn modifier dans le fichier fasta de rfl
		my $file_old=$application->{'__old_release'}."/".$application->{'__o_param'}->Get('path_db_rfl_intern')."/".$application->{'__intern_fasta_db'};
		my $file_new=$application->{'__current_release'}."/".$application->{'__o_param'}->Get('path_db_rfl_intern')."/".$application->{'__intern_fasta_db'};		
		# on copie dans session_path
		$cmd="mv $file_old $file_new";
		system $cmd;
		
		# on ecrase le fichier du DIR_WORKINGSPACE == old_release
		open (OUT, ">$file_old");
		my $in = Bio::SeqIO -> new( -file => $file_new, '-format' => 'Fasta' ) ;
		my $line;
		while ( my $seq = $in->next_seq() )
		{
			if ($seq->id() =~ /$rna_id/)
			{
				$line=$seq->id().$application->GetRna($rna_id)->GetSequence()."\n"; # seqData
			}
			else
			{
				$line=$seq->id().$seq->seq();
			}
			print OUT $line;
		}
		$in->DESTROY();
		close(OUT);
		$O_PARAM_WB->Set('FamilyDisplay',$family_id);
		$O_PARAM_WB->Delete('__wb_bounds_changed');
		$O_PARAM_WB->Set('RnaDisplay',$rna_id);
		&DisplayRna("NoEdit");
		$cmd="rm -rf $session_space/".$application->{'__o_param'}->Get('path_db');
		#system $cmd;

	}
	else # on calcule les modif de la famille puis on affiche
	{
		my ($oldout, $olderr) = &CloseStd();	
		#$application->CreateTreeDir();
		my $fam=$application->GetFamily($family_id);
		# sauve dans session dir
		$fam->SaveRnaml($session_space."/".$application->{'__o_param'}->Get('path_db_learn_family_xml'), $session_space."/".$application->{'__o_param'}->Get('path_db_learn_family_tmp'));
		&DumpFamilyFiles($fam);

		$application->GetRna($rna_id)->SaveRnaml($session_space."/".$application->{'__o_param'}->Get('path_db_learn_rna_xml'), $session_space."/".$application->{'__o_param'}->Get('path_db_learn_rna_tmp'));
		# pour display family on modifie le DIR_WORKSPACE
		my $save_wks=$DIR_WORKSPACE;
		$DIR_WORKSPACE=$RH_WEBBUILDER->GetSessionPath();
		$O_PARAM_WB->Set('FamilyDisplay',$family_id);
		&OpenStd($oldout, $olderr) ;
		&DisplayFamily("NoEdit");
		#
		$DIR_WORKSPACE=$save_wks;
		my $string_inputs='<center><INPUT name="button_reset_rna" type="submit" value="Reset rna" class="button" >
		<INPUT name="button_valid_annotation" type="submit" value="Validate '.$rna_id.' in '.$O_AUTH->GetLogin().' workspace" class="button" ></center>				
					<INPUT name="Family" type="hidden" value="'.$family_id.'" >
					<INPUT name="RnaEdit" type="hidden" value="'.$rna_id.'" >
					<INPUT name="__wb_rna_annotation_validated" type="hidden" value="1" >
					<INPUT name="__wb_rna_definition_validated" type="hidden" value="'.$O_PARAM_WB->Get('__wb_rna_definition_validated').'" >
					<INPUT name="__wb_bounds_changed" type="hidden" value="'.$O_PARAM_WB->Get('__wb_bounds_changed').'" >
					 ';
		&PrintForm($O_PARAM_WB->Get('__wb_main_menu'), "EditRna",$string_inputs);
	}
}


=head2 procedure PrintLinkFiles

 Title        : PrintLinkFiles
 Prerequisite : 
 Function     : Print links on family files (fasta, multalin ...)
 Args         : $family_file : rnaml file
                $download_file : path of files without extension
 
=cut

sub PrintLinkFiles
{
	my ($family_file,$download_file)=@_;
	
	my $family_id=$O_PARAM_WB->Get('FamilyDisplay');
	my $alnfile=$DIR_WORKSPACE."/".$O_PARAM_CGI->Get('cgi_dir_db_rfl')."/$family_id/$family_id$Var::E_ALN";
	#my $tree_ok = 0;
	my $tmptreefile  = "tree.$$".time;
	my $tmptreeurl   = $RH_WEBBUILDER->GetSessionUrl()."/$tmptreefile.png";
	my $tmptreepath  = $RH_WEBBUILDER->GetSessionPath()."/$tmptreefile";
	my $drawtree_error = 0;
	if ( -e $alnfile )
	{
		my $cde = "cp $alnfile ".$RH_WEBBUILDER->GetSessionPath();
		`$cde`;
		my $cde = "cd ".$RH_WEBBUILDER->GetSessionPath()." ; ".$O_PARAM_CGI->Get('cgi_prg_clustal')." -infile=$family_id$Var::E_ALN -outfile=$family_id$Var::E_PH -tree";
		`$cde`;
		my $linesize=6;
		my $textspace=3;
		my $imageheight=0;
		my $imagewidth=800;
		my $bordersize=200;
		eval 
		{ 
			my @refnodes=JgoughPhylo->ReadTree("$family_id$Var::E_PH");
			my (%labels,%nodedata,%linesizes,%backlinesizes);
			my $i=$refnodes[0];
			my %nodes=%$i;
			JgoughPhylo->DrawTree($tmptreepath,$linesize,$textspace,$imageheight,$imagewidth,$bordersize,$refnodes[0],$refnodes[1],\%labels,\%nodedata,\%linesizes,\%backlinesizes);
		};
		$drawtree_error = 1 if ( $@ );
	}

	print '
	<p class="text">
		<a target=new href="'.$family_file.'" class="button">Rnaml</a> 
		<a target=new href="'.$download_file.$Var::E_FA.'" class="button">Fasta</a> 
		<a target=new href="'.$download_file.$Var::E_MUL.'" class="button">Multalin</a> 
		<a target=new href="'.$download_file.$Var::E_ALN.'" class="button">Clustal</a> 
		<a target=new href="'.$download_file.$Var::E_MSS.'" class="button">MSS</a> 
		<a target=new href="'.$download_file.$Var::E_STO.'" class="button">Stockholm</a> 
		';
	print '<a target=new href="'.$tmptreeurl.'" class="button">Tree</a>' if ( ! $drawtree_error );
	print '</p>';
}

=head2 procedure DisplayFamily

 Title        : DisplayFamily
 Prerequisite : none
 Function     : Print the detail of an family. 
 
=cut

sub DisplayFamily
{
	my $action=shift;
	my $workspace=$O_PARAM_WB->Get('__wb_workspace') ;

	my $family_id=$O_PARAM_WB->Get('FamilyDisplay');
	my $family_file=$DIR_WORKSPACE."/".$O_PARAM_CGI->Get('cgi_dir_rnaml_family')."/".$family_id.$Var::E_XML;
	my $nb_sub_car=$O_PARAM_CGI->Get('cgi_param_substr');
	
	my $download_file=$DIR_WORKSPACE."/".$O_PARAM_CGI->Get('cgi_dir_db_rfl')."/".$family_id."/".$family_id;
	$download_file=substr($download_file,$nb_sub_car-1);
	
	if ($action ne "NoEdit")
	{
	print '<h1 class="learn">Family view </h1>';
	}
	&PrintLinkFiles(substr($family_file,$nb_sub_car-1),$download_file);
	
	# Command : extraction des donn�es
	my $url=$RH_WEBBUILDER->GetUrl('__wb_function');
	my $result=$RH_WEBBUILDER->GetSessionPath()."/DisplayFamily.xhtml";
	my $param='--stringparam link_rfam "'.$O_PARAM_CGI->Get('cgi_link_rfam').'"'." --stringparam index_car_substr_img $nb_sub_car  --stringparam url '".$url."' --stringparam fnt_rna DisplayRna";
	my $cmd = $O_PARAM_CGI->Get('cgi_prg_xsl')." $param $cgi_dir_xsl/". $O_PARAM_CGI->Get('cgi_xsl_print_family') ." $family_file  > $result";
#print $cmd;
	`$cmd`;
	&DisplayResult($result);
	print "<br />";
	
	if ($workspace eq "private" && $action ne "NoEdit")
	{
		my $string_inputs='
				<center>
					<INPUT type="submit" value="Edit" class="button" >
					<INPUT name="FamilyEdit" value="'.$family_id.'" type="hidden" />
				</center>';
		# en post  il faut faire passer tout les parametres / test effectuer avec action contenant cgi + les valeurs inchang�es(ne fonctionne pas)
		&PrintForm($O_PARAM_WB->Get('__wb_main_menu'), "EditFamily",$string_inputs);
	}
	print "<br />";
}

sub ClearSessionPath
{
	system "rm -rf ".$RH_WEBBUILDER->GetSessionPath()."/*";
}


=head2 procedure EditFamily

 Title        : EditFamily
 Prerequisite : none
 Function     : Treat data from form and call functions to print formulaire
 
=cut

sub EditFamily
{
	
	my ($oldout, $olderr)=&CloseStd();
	#&Trace();
	my @a_keys=$O_PARAM_WB->GetKeys("button");
	my $clic=$#a_keys;
	# au premier passage dans le formulaire ou lors du reset
	if ($clic==-1 || $O_PARAM_WB->IsDefined('button_reset_family'))
	{
		$O_PARAM_WB->Set('__wb_valid_member',0)
		&ClearSessionPath();
		$clic=-1;
		$O_PARAM_WB->Set('__wb_rnas_to_del',"");
	}
	

	my $id_family=$O_PARAM_WB->Get('FamilyEdit');
	# recup�re la liste des fichiers ( famille en cours et sous familles )
	my $cmd = "ls ".$RH_WEBBUILDER->GetSessionPath()."/".$O_PARAM_CGI->Get('cgi_dir_rnaml_family')."/$id_family*";
	#print $cmd;
	my @lst_fam=`$cmd 2> /dev/null`;
	my @id_fam;
	if ($#lst_fam>0)
	{
		for (my $i=0; $i <=$#lst_fam; $i++)
		{
			my (@a_name)=split(/[\/.]/,$lst_fam[$i]);
			push (@id_fam,$a_name[$#a_name-1]);
		}
		my $families = join(" ",@id_fam );
		
	}
	else
	{
		$id_fam[0]=$id_family;
	}
	
	my $application=&LoadRnaObject( "", $O_PARAM_CGI->Get('cgi_param_learn_cfg'), $RH_WEBBUILDER->GetSessionPath(), $DIR_WORKSPACE,$O_PARAM_CGI->Get('cgi_mask_cfg_release'), $O_PARAM_CGI->Get('cgi_mask_cfg_old_release'),$clic,"EditFamily" ,@id_fam);
	
	my $o_family=$application->GetFamily($id_family);
	
	# gestion du changement de nom de l'image pour la cache	
	# JER ca meriterait une fonction 
	my $path_img=$o_family->GetStructure()->GetImage();
	#path/img/RFL00001_1.jpg ou path/img/RFL00001.jpg
	print "IMG : $path_img <Br />";
	$path_img=~s/$Var::E_IMG//;	
	
	my @img=split(/_/,$path_img);
	if ($img[$#img] =~ /^[0-9]+$/)
	{
		$img[$#img]++;
	}
	else
	{
		push (@img, "0");
	}
	my $new_path_img=join("_",@img);
	$new_path_img.=$Var::E_IMG;
	$path_img.=$Var::E_IMG;
	my $cmd="cp $path_img $new_path_img";
	system $cmd;
	$o_family->GetStructure()->SetImage($new_path_img);

	# changement des directory
	$o_family->SetRflDir($RH_WEBBUILDER->GetSessionPath()."/".$application->{'__o_param'}->Get('path_db_rfl'));
	$o_family->SetPath($RH_WEBBUILDER->GetSessionPath()."/".$application->{'__o_param'}->Get('path_db_learn_family'));
	
	my $family_file=$RH_WEBBUILDER->GetSessionPath()."/".$application->{'__o_param'}->Get('path_db_learn_family_xml')."/$id_family.xml";
	my $download_file=$RH_WEBBUILDER->GetSessionPath()."/".$application->{'__o_param'}->Get('path_db_rfl')."/$id_family/$id_family";
	
	my $nb_sub_car=$O_PARAM_CGI->Get('cgi_param_substr');
	
	&InitAtt($application,$o_family); # a partir du formulaire s'il a deja �t� rempli
	
	
	if ( $O_PARAM_WB->IsDefined('button_valid_member') )
	{
		$O_PARAM_WB->Set('__wb_valid_member',1);
	}
	
	my $msg_err="";
	
	#Edition des membres
	if ( $O_PARAM_WB->Get('__wb_valid_member') == 0 )
	{
		my @a_rnas=$O_PARAM_WB->GetKeys("rna_");
		if ( $#a_rnas >-1 )
		{	
			# on verifie que l'on ne supprime pas tout les arn de la famille
			if ($o_family->NumberOfRna() - ($#a_rnas +1) <= 0)
			{
				$msg_err= '<p class="error">Error: it is not allowed to delete all RNA of a family</p>';
			}
			else
			{
				#print "<br />KEYS : $#a_rnas ";
				foreach my $rna_key (@a_rnas)
				{
					next if ($rna_key eq "");
					$o_family->DeleteRnaFromId($O_PARAM_WB->Get($rna_key));
				}
				
				&DumpFamilyFiles($o_family);
				# suppression d'ARN
				if ( $O_PARAM_WB->IsDefined('button_junk_rna') )
				{
					my @rna_fam;
					foreach my $rna_key (@a_rnas)
					{
						push ( @rna_fam, $O_PARAM_WB->Get($rna_key) );
					}
					my $rnas= join(';', @rna_fam );
					#Ajout dans la variable wb des valeurs des arn a supprimer
					$O_PARAM_WB->Set('__wb_rnas_to_del',$rnas.";".$O_PARAM_WB->Get('__wb_rnas_to_del'));
					
				}
				# creation d'une nouvelle famille
				elsif ( $O_PARAM_WB->IsDefined('button_savein_rna') )
				{
					# recup�re l'id de la nouvelle famille deja calcule et incrit dans le bouton.
					my ($id_fam)=$O_PARAM_WB->Get('button_savein_rna') =~ /Move\sselection\sin\snew\ssubfamily\s(RFL\d*\S)$/;
					${$application->{'__h_family'}}{$id_fam}= New RnaFamily();
					${$application->{'__h_family'}}{$id_fam}->Initialize(
					"$id_fam", 
					"$id_fam", 
					"", 
					$application->{'__today'}, 
					"", 
					"", 
					$application->{'__current_release'}."/".$$application{'__o_param'}->Get('path_db_learn_family'), 
					$application->{'__current_release'}."/".$$application{'__o_param'}->Get('path_db_rfl'),
					&Learn::GetRefProgram('RFL_FOLD', "actual"), 
					&Learn::GetRefProgram('RFL_ALIGN', "actual"), 
					&Learn::GetRefProgram('RFL_BUILD', "actual") );
					$application->{'__last_family_id'}++;
					#pour tout les arn selectionn� on les ajoute a la nouvelle famille et on sauvegarde dans le session space.
					foreach my $rna_key (@a_rnas)
					{
						my $rna_id=$O_PARAM_WB->Get($rna_key);
						${$application->{'__h_rna'}}{$rna_id}->SetFamilyAcc($id_fam);
						${$application->{'__h_family'}}{$id_fam}->AddRna(\${$application->{'__h_rna'}}{$rna_id});
						my $o_rna=$application->GetRna($rna_id);
						$o_rna->SetFamilyAcc($id_fam);
						$o_rna->SaveRnaml($RH_WEBBUILDER->GetSessionPath()."/".$O_PARAM_CGI->Get('cgi_dir_rnaml_rna'), $RH_WEBBUILDER->GetSessionPath()."/".$application->{'__o_param'}->Get('path_db_learn_rna_tmp'));
						
					}
					&DumpFamilyFiles(${$application->{'__h_family'}}{$id_fam});

					${$application->{'__h_family'}}{$id_fam}->SaveRnaml($RH_WEBBUILDER->GetSessionPath()."/".$O_PARAM_CGI->Get('cgi_dir_rnaml_family'), $RH_WEBBUILDER->GetSessionPath()."/".$application->{'__o_param'}->Get('path_db_learn_family_tmp'));
				}
			}
		}
	}
	# si on a valider les membres de la famille => on proviens du formulaire de la structure
	elsif ($O_PARAM_WB->Get('__wb_valid_member') == 1 &&  not $O_PARAM_WB->IsDefined('button_valid_annotation') )
	{
		my $res=0;
		# Modification de la structure et/ou alignement
		if ( $O_PARAM_WB->IsDefined('button_update_aln') )
		{
			if  ( $O_PARAM_WB->Get('fam_aln') ne "")
			{	
				
				my $consensus="";
				
				
				# modification de l' alignement
				my $tmp_in=$RH_WEBBUILDER->GetSessionPath()."/".$application->{'__o_param'}->Get('path_db_rfl')."/$id_family/$id_family.tmp";
				my $tmp_mul=$RH_WEBBUILDER->GetSessionPath()."/".$application->{'__o_param'}->Get('path_db_rfl')."/$id_family/$id_family.aln";
				my $cmd;
				
				my @aln=split(/\n/,$O_PARAM_WB->Get('fam_aln'));
				
				my $in_aln = Bio::SeqIO->new( -file => ">$tmp_in", '-format' => 'Fasta' );
				my $seq = Bio::Seq->new();
				
				
				my $is_cons=0;
				my $line="";
				my $i;
				chomp (@aln);
				if ( $O_PARAM_WB->Get('fam_struct') ne "" && $O_PARAM_WB->Get('fam_aln') !~ /consensus/ )# erreur
				{	
					$res=3;
				}
				else
				{
				for ($i=0; $i<= $#aln; $i++ ) # pour chaque sequence de l'alignement
				{	
					
					$line = $aln[$i];
					next if ($line eq "");
					if ($line =~ /^>/ )
					{
						my $input_seq="";
					 	chomp ($line);
					 	
					 	# recupere l'identifiant de la sequence
					 	$line =~ s/>//;	
					 	my @a_tmp=split (' ',$line );
					 	$line=$a_tmp[0];
					 	if ($o_family->HaveRna($line))
					 	{
					 		$seq->id($line);
					 	}
					 	elsif ($line eq "consensus" )
					 	{
					 		$is_cons=1;
					 	}
					 	else # erreur
					 	{
					 		$res=1;
							last;
					 	}
					 	$i++; # JER ca depasse!!
					 	$line=$aln[$i];
					 	
					 	chomp ($line);
					 	while ($line !~ /^>/ && $i <= $#aln)
					 	{
							$input_seq.=$line;
							$i++;
							$line=$aln[$i];
							chomp ($line);
					 	}
					 	$i--;
					 	$input_seq=~s/[\r\n|\s|\<br\>|\t]*//g;
					 	
					 	if ($is_cons )
					 	{
					 		$consensus=$input_seq;
					 	}
					 	else
					 	{
							if ($input_seq  !~ /[ACGTU-]/i)
							{
								$res = 2;
								last;
							}
							else
							{
								$seq->seq($input_seq);
							}
							$in_aln->write_seq($seq);
						}
					}
				}
 				}
				if ($res ==3 )
				{
					$msg_err= '<p class="error">Error: if you enter both secondary structure and aligment, the corresponding consensus is mandatory</p>';
				}
				elsif ($res !=0 )
				{
					$msg_err= '<p class="error">Error: unexpected alignment error :'.$res.'</p>';
				}
				else
				{
					if ($consensus ne "")
					{
						$consensus=~tr/\.-/__/;
						open (MUL, ">".$o_family->{'__clustal_file'});
						print MUL ">consensus\n";
						print MUL "$consensus\n";
						close (MUL);
						$o_family->GetStructure()->SetProgram(Learn::GetRefProgram('R_FOLD_ALT', "actual"));
						$o_family->SetComputed("Yes");
						
						$cmd="cp $tmp_in ".$o_family->GetFile('multalin') ;
						system $cmd;
						$cmd = $O_PARAM_CGI->Get('cgi_prg_reformat') ." $tmp_in    | perl -ne \'{split;if ( \$#_==1 ) { \$_=sprintf(\"%-20s%s\\n\",\$_[0],\$_[1]); }; print; }\' > ". $o_family->{'__clustal_file'} ;
						$o_family->SetConsensus($consensus);
						$o_family->SetLength(length($consensus));
						&DumpFamilyFiles($o_family);
					}
					else
					{
						$cmd="cp $tmp_in ".$o_family->GetFile('multalin') ;
						system $cmd;
						
						$cmd = $O_PARAM_CGI->Get('cgi_prg_reformat') ." $tmp_in    | perl -ne \'{split;if ( \$#_==1 ) { \$_=sprintf(\"%-20s%s\\n\",\$_[0],\$_[1]); }; print; }\' > ". $o_family->{'__clustal_file'} ;
						system $cmd;
						if ( ${$o_family->GetStructure()->GetProgram()}->GetType() !~ /^RFL_FOLD/ )
						{
							$o_family->GetStructure()->SetProgram(Learn::GetRefProgram('RFL_FOLD', "actual"));
						}
						$o_family->SetComputed("Yes");
						if  ( $O_PARAM_WB->Get('fam_struct') eq "")
						{
							$o_family->SetComputed("Yes");
							&DumpFamilyFiles($o_family);
						}
					}
				}
			}
			
			if  ( $O_PARAM_WB->Get('fam_struct') ne "" && $res ==0)
			{
				my $okou= $o_family->GetStructure()->GetStructure();
				#Modification de la structure et recalcul de l'image en se basant sur le consensus
				my $struct=$O_PARAM_WB->Get('fam_struct');
				chomp($struct);
				$struct=~s/[\r\n|\s|\<br\>|\t]*//g;
				my $seq_lg=length($o_family->GetConsensus());
				
				if ( $seq_lg == length($struct))
				{
					$o_family->GetStructure()->SetStructure($struct);
					$o_family->ComputePlotEval($o_family->GetConsensus());
					$o_family->SetComputed("Yes");
					if ( $o_family->GetStructure()->GetStructure() eq '' )
					{
						$o_family->GetStructure()->SetStructure($okou);
						$o_family->ComputePlotEval($o_family->GetConsensus());
						$msg_err= '<p class="error">Error: unable to update the structure, brackets must be balanced</p>';
					}
				}
				else
				{
					$msg_err= '<p class="error">Error: sequence and structure have different length : sequence length='.$seq_lg.', structure length='.  length($struct).'</p>';
				}
			}
			
		}	
	}
	else # sauvegarde de la famille !!!
	{
		# SAUVEGARDE DE L'ENSEMBLES DES FAMILLES
		
		# suppression des fichier xml des rna supprimer
		my @rna_to_del= split (";", $O_PARAM_WB->Get('__wb_rnas_to_del'));
		foreach my $rna (@rna_to_del) 
		{
			my $cmd= "rm ".$DIR_WORKSPACE."/".$O_PARAM_CGI->Get('cgi_dir_rnaml_rna')."/$rna.xml";
			system $cmd;
		}
		
		# pour toutes les familles (sous familles) du session space on sauve
		foreach my $id_of_fam (@id_fam) 
		{
			
			my $o_family_tmp=$application->GetFamily($id_of_fam);
			
			my $cmd = "cp -r ".$o_family_tmp->{'__cm_file'}." ".
			$DIR_WORKSPACE."/".$application->{'__o_param'}->Get('path_db_rfl_intern');
			system $cmd;

			my $rfl_tmp_path = $o_family_tmp->GetRflDir();
			my $rfl_ws_path = $DIR_WORKSPACE."/".$application->{'__o_param'}->Get('path_db_rfl');
			$cmd = "cp -r $rfl_tmp_path/$id_of_fam  $rfl_ws_path";
			system $cmd;
			
			$o_family_tmp->SetRflDir($rfl_ws_path);

			my $img_ws_path=$DIR_WORKSPACE."/".$application->{'__o_param'}->Get('path_db_learn_family_img')."/$id_of_fam$Var::E_IMG";
			my $img_sess_path = $o_family_tmp->GetStructure()->GetImage();
			$cmd = "cp  $img_sess_path $img_ws_path";
			print "<br>$id_of_fam // $cmd\n";
			system $cmd ;
			
			$o_family_tmp->GetStructure()->SetImage($img_ws_path);
			
			$o_family_tmp->SetPath($DIR_WORKSPACE."/".$O_PARAM_CGI->Get('cgi_dir_rnaml_family'));
			$o_family_tmp->SetComputed("Yes");

			$o_family_tmp->SaveRnaml ( $DIR_WORKSPACE."/".$O_PARAM_CGI->Get('cgi_dir_rnaml_family') ,  $DIR_WORKSPACE."/".$application->{'__o_param'}->Get('path_db_learn_family_tmp') );
			
			foreach my $ro_rna (@{$o_family_tmp->GetRaRna()})
			{
				# on remodifie les path des fichier associes  a l'arn 
				print "<br />". $$ro_rna->GetId()." : $DIR_WORKSPACE";
				$$ro_rna->GetStructure()->SetPathsSS($DIR_WORKSPACE."/".$application->{'__o_param'}->Get('path_db_learn_rna_ss'));
				$$ro_rna->GetStructure()->SetPathImg($DIR_WORKSPACE."/".$application->{'__o_param'}->Get('path_db_learn_rna_img'));
				
				$$ro_rna->SaveRnaml($DIR_WORKSPACE."/".$O_PARAM_CGI->Get('cgi_dir_rnaml_rna'), $DIR_WORKSPACE."/".$application->{'__o_param'}->Get('path_db_learn_rna_tmp'));
			}
		}
		
	}
	&OpenStd($oldout, $olderr);
	if ($msg_err ne "" )
	{
		print $msg_err;
	}
	if ( $O_PARAM_WB->IsDefined('button_valid_annotation') )
	{
		$O_PARAM_WB->Set('FamilyDisplay',$id_family);
		&DisplayFamily();
	}	
	else
	{
		
		if ( $O_PARAM_WB->Get('__wb_valid_member') == 0 || $clic==-1)
		{
			print '<h1 class="learn">RNA family annotation 1/2 : Family definition (member selection)</h1>';
		}
		else
		{	
			print '<h1 class="learn">RNA family annotation 2/2 : Structure definition </h1>';
		}
		&PrintLinkFiles(substr($family_file,$nb_sub_car-1),substr($download_file,$nb_sub_car-1));

		# Affichage du formulaire
		print ' <FORM action="'.$RH_WEBBUILDER->GetCgi().'" name="FormFamily" method="post">';
		&PrintDefinitionFamilyForm($application,$o_family);
		my $string_input='<center><INPUT name="__wb_valid_member" type="hidden"  value="'.$O_PARAM_WB->Get('__wb_valid_member').'">
		<INPUT name="FamilyEdit" type="hidden"  value="'.$id_family.'">
		<INPUT name="button_reset_family" type="submit" value="Reset family" class="button" >
		<INPUT name="__wb_rnas_to_del" type="hidden"  value="'.$O_PARAM_WB->Get('__wb_rnas_to_del').'"> ' ;
		if ( $O_PARAM_WB->Get('__wb_valid_member') == 0 || $clic==-1)
		{
			&PrintStructureFamilyInfo($application,$o_family);
			&PrintMemberFamilyForm($application,$o_family, "form");
			$string_input.='<INPUT name="button_valid_member" type="submit" value="Validate   '.$id_family.' definition" class="button" ></center> ';
		}
		else
		{
			&PrintMemberFamilyForm($application,$o_family, "noform");
			&PrintStructureFamilyForm($application,$o_family);
			$string_input.='<INPUT name="button_valid_annotation" type="submit" value="Validation of '.$id_family.' in '.$O_AUTH->GetLogin().' workspace" class="button" > </center>';
		}
		
		&PrintForm($O_PARAM_WB->Get('__wb_main_menu'), "EditFamily",$string_input, "NoAction");
		print "<br />";
		($oldout, $olderr)=&CloseStd;
		
		$o_family->SaveRnaml($RH_WEBBUILDER->GetSessionPath()."/".$O_PARAM_CGI->Get('cgi_dir_rnaml_family'), $RH_WEBBUILDER->GetSessionPath()."/".$application->{'__o_param'}->Get('path_db_learn_family_tmp'));
		foreach my $ro_rna (@{$o_family->GetRaRna()})
		{			
			# on remodifie les path des fichier associer � l'arn 
			$$ro_rna->GetStructure()->SetPathsSS($RH_WEBBUILDER->GetSessionPath()."/".$application->{'__o_param'}->Get('path_db_learn_rna_ss'));
			$$ro_rna->GetStructure()->SetPathImg($RH_WEBBUILDER->GetSessionPath()."/".$application->{'__o_param'}->Get('path_db_learn_rna_img'));
			$$ro_rna->SaveRnaml($RH_WEBBUILDER->GetSessionPath()."/".$O_PARAM_CGI->Get('cgi_dir_rnaml_rna'), $RH_WEBBUILDER->GetSessionPath()."/".$application->{'__o_param'}->Get('path_db_learn_rna_tmp'));
		}
		&OpenStd($oldout, $olderr);
	}
}

=head2 procedure InitAtt

 Title        : InitAtt
 Prerequisite : none
 Function     : initialise attribut of family from value of form
 Args         : $application : a learn object
                $o_family : a family object
                
=cut

sub InitAtt
{
	my ($application,$o_family)=(@_);
	if (! $O_PARAM_WB->IsDefined('button_reset_family') )
	{
		$o_family->SetDesc(&EncodeAccent($O_PARAM_WB->Get('fam_desc'))) if ($O_PARAM_WB->IsDefined('fam_desc'));
		$o_family->SetDbxref(&EncodeAccent($O_PARAM_WB->Get('fam_dbxref'))) if ($O_PARAM_WB->IsDefined('fam_dbxref')) ;
		$o_family->SetName(&EncodeAccent($O_PARAM_WB->Get('fam_name'))) if ($O_PARAM_WB->IsDefined('fam_name'));
		$o_family->SetStatus($O_PARAM_CGI->Get('cgi_status_'.$O_PARAM_WB->Get('fam_status')) )  if ($O_PARAM_WB->IsDefined('fam_status')) ;
		$o_family->SetLastUpd($application->{'__today'});
	}
	
}	



=head2 procedure PrintMemberFamilyForm

 Title        : PrintMemberFamilyForm
 Prerequisite : none
 Function     : Print the alignment with a checkbox on each sequence to delete it or save in another family
 Args         : $application : a learn object
                $o_family : a family object.
                $mode : print member with checkbox or not.
                if $mode eq "form" print checkbox
=cut

sub PrintMemberFamilyForm
{
	my ($application,$o_family, $mode)=(@_);
	print '<h2 class="learn">Family members: </h2>';
	
	print '
	<pre> <table border="1"><tbody>
	<tr><td></td><td>Structure</td><td>'.$o_family->GetStructure()->GetStructure().'</td></tr>
	<tr><td></td><td>Consensus</td><td>'.$o_family->GetConsensus().'</td></tr>';
	# on parcourt le fichier d'alignement pour afficher l'alignement
	my $mul_file=$o_family->GetFile("multalin");
	
	my $in_aln = Bio::SeqIO->new( -file => "$mul_file", '-format' => 'Fasta' );
	my $seq;
	while( $seq = $in_aln->next_seq() ) # pour chaque alignement on va créer
	{	 
		if (defined $seq->id() &&  !($seq->id() =~/\#2$/ ) && $o_family->HaveRna($seq->id())) # verifie que l'id correspond a une copy des Arn
		{
			print '
			<tr><td>';
			print '<input type="checkbox" name="rna_'.$seq->id().'" value="'.$seq->id().'">' if ( $mode eq "form");
			print '</td><td>'.$seq->id(). '</td><td>'.$seq->seq().'</td></tr>';
		}
	}
	print '	</tbody>
	</table></pre>';
	if ($mode eq "form")
	{
		my $id_fam=$o_family->GetId();
		my $dir_family = $application->{'__old_release'}."/".$$application{'__o_param'}->Get('path_db_learn_family_xml') ;
		my $new_xml_family = $application->{'__current_release'}."/".$$application{'__o_param'}->Get('path_db_learn_family_xml');
		# on cherche le plus grand accession des familles
		my $cmd = "ls $dir_family/$id_fam* $new_xml_family/$id_fam*";
		my @lst_fam=`$cmd 2> /dev/null`;
		for (my $i=0; $i <=$#lst_fam; $i++)
		{
			my (@a_name)=split('/',$lst_fam[$i]);
			$lst_fam[$i]=$a_name[$#a_name];
			
		}
		@lst_fam= sort(@lst_fam) ;
		my $fam_xml=$lst_fam[$#lst_fam];
		chomp ($fam_xml);
		my ($letter)=$fam_xml=~/RFL\d*(\D).xml/;
		if (defined ($letter) )
		{
			my $i;
			for ($i=0; $i<=$#alphabet;$i++)
			{
				if ($alphabet[$i] eq $letter)
				{	$i++;
					$letter=$alphabet[$i];
					last;
				}
			}
			if ( $i>$#alphabet)
			{
			$letter=$alphabet[1];
			}
			
		}
		else
		{
			$letter=$alphabet[1];
		}
		
		print '
		<center><INPUT type="submit" name="button_savein_rna" value="Move selection in new subfamily '.$id_fam.$letter.'" class="button">
		<INPUT type="submit" name="button_junk_rna" value="Delete selection" class="button">
		</center><br />
		<hr class="learn"/><br />';

		
		
	}
}

=head2 procedure PrintStructureFamilyInfo

 Title        : PrintStructureFamilyInfo
 Prerequisite : none
 Function     : Print data ofr the alignemnt and the structure
 Args         : $application : a learn object
                $o_family : a family object.

=cut


sub PrintStructureFamilyInfo
{
	my ($application,$o_family)=(@_);
	print '
	<h2 class="learn">Structure: </h2>
	<div class="div_learn">
		<table>
		<tbody>
			<tr valign="top">
				<td>
				<br /><label class="text1">Structure computed by: </label> '.${$o_family->GetStructure()->GetProgram()}->GetName().'<br />
				<label class="text1">Free-energie: </label>
				'.$o_family->GetStructure()->GetFreeEnergy().'<br /><br />
			
			<label class="text1">Parenthesis structure : </label>
			';
			if (defined($o_family->GetStructure()->GetStructure()) && ! -e $o_family->GetStructure()->GetStructure())
			{
					print '<pre>';
					my $seq_data=$o_family->GetStructure()->GetStructure();
					my $new_seq_data="";
					my $i=0;
					while ( $i < length($seq_data))
					{
						$new_seq_data=substr($seq_data,$i,50);
						print "$new_seq_data<br />";
						$i+=50;
					}
					print '</pre>';
			}
	print '	</td>
		<td>
		<p class="node"><img src="'.substr($o_family->GetStructure()->GetImage(),$O_PARAM_CGI->Get('cgi_param_substr')-1).'" class="ss"></p>
		<td>
		</tr>
		</tbody>
		</table>
	</div>
	';
	
}

=head2 procedure PrintStructureFamilyForm

 Title        : PrintStructureFamilyForm
 Prerequisite : none
 Function     : Print form for the alignemnt and the structure
 Args         : $application : a learn object
                $o_family : a family object.

=cut

sub PrintStructureFamilyForm
{
	my ($application,$o_family)=(@_);
	print '
	<h2 class="learn">Structure : </h2>
	<div class="div_learn">
	<table>
	<tbody>
	<tr>
	<td>
		<table>
		<tbody>
			<tr>
				<td><label class="text1">Structure computed by:</label></td>
				<td>'.${$o_family->GetStructure()->GetProgram()}->GetName().'</td>
				<td><label class="text1">Free-energy:</label></td>
				<td>'.$o_family->GetStructure()->GetFreeEnergy().'</td>
			</tr>
		</tbody>
		</table>
			<label class="text1">Parenthesis structure :</label>
			';
			if (defined($o_family->GetStructure()->GetStructure()) && ! -e $o_family->GetStructure()->GetStructure())
			{
					print '<pre>';
					my $seq_data=$o_family->GetStructure()->GetStructure();
					my $new_seq_data="";
					my $i=0;
					while ( $i < length($seq_data))
					{
						$new_seq_data=substr($seq_data,$i,50);
						print "$new_seq_data<br />";
						$i+=50;
					}
					print '</pre>';
			}
			print '
				<label class="text1">Enter your parenthesis structure :</label>
				<br />
				<textarea name="fam_struct" rows="3" class="saisie_seq"></textarea>';
			print '	<br /><label class="text1">Enter your alignment : (consensus, if any, must be labelled "consensus". The consensus is required when both sec. struct. and multiple alignment are uploaded)</label>
		<br />';
		my $nb_line=$o_family->NumberOfRna();
		$nb_line=15 if ($nb_line>15);
		$nb_line=5 if ($nb_line<5);
		print '
		<textarea name="fam_aln" rows="'.$nb_line.'" class="saisie_seq" wrap="physical"></textarea>
		<br />
		<label class="text1">Accepted format: multalin</label> 
		
		<INPUT type="submit" name="button_update_aln" value="Update" class="button">
	</td>
	<td>
		<p class="node"><img src="'.substr($o_family->GetStructure()->GetImage(),$O_PARAM_CGI->Get('cgi_param_substr')-1).'" class="ss"></p>
	</td>
	</tr>
	</tbody>
	</table>
	</div>';
	
	
}

=head2 procedure PrintDefinitionFamilyForm

 Title        : PrintDefinitionFamilyForm
 Prerequisite : none
 Function     : Print form of general information of a family
 Args         : $application : a learn object
                $o_family : a family object.

=cut

sub PrintDefinitionFamilyForm
{
	my ($application,$o_family)=(@_);
	
	print ' <h1 class="learn">'.$o_family->GetId().'</h1>
	<h2 class="learn">Description: </h2>
	<div class="div_learn">
	<table>
	<tbody><tr>
			<td><label class="text1">Id:</label></td>
			<td><input type="text" name="fam_name" value="'.$o_family->GetName().'" class="saisie_seq" ></td>
			<td>
			<label class="text1">Length</label> 
			</td>
			<td>
			'.$o_family->GetLength().'
			</td>
			
		</tr>';
	print ' <tr>
			<td><label class="text1">Dbxref:</label></td>
			<td><input type="text" name="fam_dbxref" value="'.$o_family->GetDbxref().'" class="saisie_seq" ></td>
			<td>
				<label class="text1">Nb of RNA(s):</label>
			</td>
			<td>
				'.$o_family->NumberOfRna().'
			</td>
			
		</tr>';
	print ' <tr>
			<td><label class="text1">Status:</label></td>
			<td>
			<select NAME="fam_status">';
				foreach my $key ($O_PARAM_CGI->GetKeys("cgi_status_"))
				{
					my $sub_key=$key;
					$sub_key=~s/cgi_status_//;
					if ($key ne "")
					{
						print '<option VALUE="'.$sub_key.'"';
						my $value = $O_PARAM_CGI->Get($key);
						print ' selected ' if ($o_family->GetStatus() =~ /$value/i);
						print '>'.$value.'</option>';
					}
				}
				print '</select>
			</td>
			<td><label class="text1">Last updated:</label></td>
			<td>
				'.$o_family->GetLastUpd().'
			</td>
		</tr>';
	print ' <tr>
			<td><label class="text1">Comment:</label></td>
			<td><input type="text" name="fam_desc" value="'.$o_family->GetDesc().'" class="saisie_seq" ></td>
			<td></td>
			<td></td>
		</tr>
	</tbody>
	</table>
	</div>';

		
}


=head2 procedure PrintDBStatus

 Title        : PrintDBStatus
 Prerequisite : none
 Function     : Print the status of database : 
		in public database : from a file
		in private database : just a resume, and propose to reload it from the public db
=cut

sub PrintDBStatus
{
	
	if ( $O_AUTH->IsPrivilege('annotator')  )
	{
		&SelectWorkspace($O_PARAM_WB->Get('__wb_main_menu'),$O_PARAM_WB->Get('__wb_function') );
	}
	print '<h1 class="learn">Database status</h1>			
			<div name="learn" >
			<p class="data">';

	if ($O_PARAM_WB->Get('__wb_workspace') eq "private" )
	{
		if (! -d $DIR_WORKSPACE ) #si sont workspace n'exite pas
		{
			print 'You don\'t have a user workspace<br />
			Do you want to create it ?<br />';
		
		}
		else
		{
			my $res=`find $DIR_WORKSPACE/$cgi_dir_rnaml_rna -name '*.xml' | wc -l `;
			my @a_t= split(' ',$res);
			my ($rna)= $a_t[0];
			$res=`find $DIR_WORKSPACE/$cgi_dir_rnaml_family -name '*.xml' | wc -l `;
			@a_t= split(' ',$res);
			my ($fam)= $a_t[0];
				
			my $cmd = "find $DIR_WORKSPACE/$cgi_dir_rnaml_rna -name \"*.xml\" -exec ". $O_PARAM_CGI->Get('cgi_prg_xsl')." $cgi_dir_xsl/". $O_PARAM_CGI->Get('cgi_xsl_select_organism') ."  \'{}\' \\;  ";
			#print $cmd;
			my @a_lst_org=`$cmd| sort -u`;
			
			print "Your workspace contains : 
			<ul>
			<li>$rna RNAs </li>
			<li>$fam families</li>
			<li>Species : 
			<ul>
			";
			foreach my $org (@a_lst_org)
			{
				next if ( $org =~ /<?xml / );
				print "<li>$org</li>";
			}
			print "</ul></li>";
			print "</ul>";
		}
		
		my $string_inputs='<INPUT name="reload_private" type="submit" value="Reload workspace" class="button"> <p class="error">Warning: it will erase your current workspace content</p>';
		# en post  il faut faire passer tout les parametres / test effectuer avec action contenant cgi + les valeurs inchang�es(ne fonctionne pas)
		&PrintForm($O_PARAM_WB->Get('__wb_main_menu'), $O_PARAM_WB->Get('__wb_function'),$string_inputs);
	}
	elsif ($O_AUTH->IsPrivilege('guest') || $O_PARAM_WB->Get('__wb_workspace') eq "public" )
	{
		
		my $cgi_file_status=$O_PARAM_CGI->Get('dir_learn')."/".$O_PARAM_CGI->Get('cgi_dir_release')."/".$O_PARAM_CGI->Get('cgi_file_status');
		if (-e $cgi_file_status)
		{
			open (STAT, $cgi_file_status);

			my $prog=0;
			while (my $line=<STAT>)
			{
				chomp ($line);

				my @a_tmp=split (/[\s]+/,$line,2);
				if ( ! $prog )
				{
					if ( $a_tmp[0] eq "SEQ" )
					{
						print "<b>Number of analyzed sequences :</b> $a_tmp[1] ";
					}
					elsif ( $a_tmp[0] eq "BP" )
					{
						print "( $a_tmp[1] bp )<br />";
					}
					elsif ( $a_tmp[0] eq "RNA" )
					{
						print "<b>RNAs detected : </b>$a_tmp[1]<br />";
					}
					elsif ( $a_tmp[0] eq "FAMILY" )
					{
						print "<b>Families detected :</b> $a_tmp[1]<br />";
					}
					elsif ( $a_tmp[0] eq "ORG" )
					{
						my @orgs=split (";",$a_tmp[1]);
						print "<b>Organism :</b><br />
						<ul>";
						foreach my $org (@orgs)
						{
							print "<li>$org</li>";
						}
						print "</ul>";
					}	
				}
				else
				{
					print "<li>$line</li>";
				}
				if ($line =~/PROG/ && !$prog)
				{

					print '<b>Programs used : </b><br /><ul>';
					$prog=1;
				}

			}
			print '</ul>';
		}
		else
		{
			print '<p class="error">Warning: information are not available</p>';
		}

		
	}
	print '</p>';
	print '</div>';
}












##################################################
####### Formulaire recgerche par mots cle ########
##################################################


=head2 procedure PrintSearch

 Title        : PrintSearch
 Prerequisite : none
 Function     : Print form to search by accession/keyword/organism data
 

=cut

sub PrintSearch
{

	if ($O_AUTH->IsPrivilege('annotator')  )
	{
		&SelectWorkspace($O_PARAM_WB->Get('__wb_main_menu'),$O_PARAM_WB->Get('__wb_function') );
	}

	print '<h1 class="learn">Search library using accessions or keywords</h1>';
	my $cgi = $RH_WEBBUILDER->GetCgi();
	print '<div name="learn" class="div_learn">';
	print '<FORM action="'.$cgi.'" method="post">';
		print '<p><TABLE class="presentation" >';
			print '<tr>';
				print '<td>';
					print '<LABEL class="label_seq">LeARN accession: </LABEL>';
				print '</td>';
				print '<td>';
					print '<INPUT type="text" name="input_acc" class="saisie_seq"/><br />';
					print '<LABEL class="labelExample">e.g: RFL00002 (family), NC_003413_r40 (rna)</LABEL><br />';
					print '<LABEL class="labelExample">To get all rna on a sequence, enter the sequence ID (e.g: NC_003413):</LABEL>';
				print '</td>';
			print '</tr>';
			print '<tr>';
				print '<td>';
					print '<LABEL class="label_seq">Keyword: </LABEL>';
				print '</td>';
				print '<td>';
					print '<INPUT type="text" name="input_key" class="saisie_seq"/><br />';
				print '</td>';
			print '</tr>';
			print '<tr>';
				print '<td>';
					print '<LABEL class="label_seq">Organism: </LABEL>';
				print '</td>';
				print '<td>
				<select NAME="input_org" class="saisie_seq">';
				my @org = &GetOrganism();
				
				foreach my $key (@org)
				{
					print '<option VALUE="'.$key.'">'.$key.'</option>';
				}
				print '<option VALUE="Any" selected="selected">Any</option>';
				print '</select>
				</td>';
			print '</tr>';

		print '</TABLE></p>';
	my $str_input= '<center><INPUT type="submit" value="Search" class="button" ><center>';
	$str_input.= '<p><i>Warning: the search is case sensitive</i></p>';
	&PrintForm($O_PARAM_WB->Get('__wb_main_menu'), "PrintResultSearch",$str_input, "NoAction");
	print '</div>';


}

=head2 procedure GetOrganism

 Title        : GetOrganism
 Prerequisite : none
 Function     : Return an arry with all organism analysed, get it from status file.
 

=cut
sub GetOrganism
{
	my @org=();	
	my $cgi_file_status=$O_PARAM_CGI->Get('dir_learn')."/".$O_PARAM_CGI->Get('cgi_dir_release')."/".$O_PARAM_CGI->Get('cgi_file_status');
	if (-e $cgi_file_status)
	{
		open (STAT, $cgi_file_status);
	
		my $prog=0;
		while (my $line=<STAT>)
		{
			chomp ($line);
			my @a_tmp=split (' ',$line,2);
			if ( $a_tmp[0] eq "ORG" )
			{
				@org=split (/;/,$a_tmp[1]);
			}
		}
	}
	return @org;
}

=head2 procedure PrintResultSearch

 Title        : PrintResultSearch
 Prerequisite : none
 Function     : In function of the accession number entered call an other function
 

=cut

sub PrintResultSearch
{
	my ($cmd);
	my $session_dir = $RH_WEBBUILDER->GetSessionPath();
	my $id_el=$O_PARAM_WB->Get('input_acc');
	my $keyword=$O_PARAM_WB->Get('input_key');
	my $org=$O_PARAM_WB->Get('input_org');

	if ($id_el =~ /^RFL/)
	{
		&SearchFamilies($id_el,$org, $keyword);
	}
	elsif ($id_el =~ /([A-Z]|[a-z]|[0-9])*/)
	{
		&SearchRnas($id_el,$org, $keyword);
	}
	my $str_input= '<center><INPUT type="submit" value="Return" class="button" ><center>';
	&PrintForm($O_PARAM_WB->Get('__wb_main_menu'), "PrintSearch",$str_input);
}

=head2 procedure SearchRnas

 Title        : SearchRnas
 Prerequisite : none
 Function     : Do the search on rna
 Args         : $id_el : input id element
 		$org   : input organism
 		$keyword : input keyword

=cut

sub SearchRnas
{
	my ($id_el,$org, $keyword)=@_;
	print '<h1 class="learn">Search RNA</h1>';
	print '<div class="div_learn">';
	print '<h2 class="learn">Request:</h2>';
	print "<ul>
	<li>Accession: $id_el</li>
	<li>Keyword: &nbsp;&nbsp;$keyword</li>
	<li>Organism:  &nbsp;".$org."</li></ul>";
	# Command : extraction des donn�es
	my $result=$RH_WEBBUILDER->GetSessionPath()."/SearchRnas.xhtml";
	system "rm -f $result";
	my $url = $RH_WEBBUILDER->GetUrl("__wb_function");
	my $param="--stringparam link_genbank '".$O_PARAM_CGI->Get('cgi_link_genbank')."' --stringparam url '".$url."' --stringparam fnt_family DisplayFamily --stringparam fnt_rna DisplayRna --stringparam org '".$org."'";
	my $cmd;
	print '<h2 class="learn">Results:</h2>';

	print '<center><label class="labelExample">* Name is computed </label>';
	print '<table class="presentation">
	<tbody>	<tr class="head">
	<th>RNA acc</th><th>Dbxref</th><th>Name*</th><th>Genbank</th><th>Start</th><th>End</th><th></th><th>Program</th><th>Free energy</th><th>Family</th>
	</tr>';
	
	my @lst=&GetLstOfFile($DIR_WORKSPACE."/".$O_PARAM_CGI->Get("cgi_dir_rnaml_rna"),$keyword,$id_el);
	foreach my $file (@lst )
	{
			$cmd = $O_PARAM_CGI->Get('cgi_prg_xsl')." $param $cgi_dir_xsl/".$O_PARAM_CGI->Get('cgi_xsl_search_rna') ." $file";
			#print $cmd;
			system "$cmd";
	}
	
	print '</tbody></table></center><br />	';
	print '</div>';
}

=head2 procedure SearchFamilies

 Title        : SearchFamilies
 Prerequisite : none
 Function     : Do the search on families
 Args         : $id_el : input id element
 		$org   : input organism
 		$keyword : input keyword

=cut

sub SearchFamilies
{
	my ($id_el,$org, $keyword)=@_;
	print '<h1 class="learn">Search family</h1>';
	print '<div class="div_learn">';
	print '<h2 class="learn">Request:</h2>';
	print "<ul><li>Accession: $id_el</li>
	<li>Keyword:  &nbsp;&nbsp; $keyword</li>
	<li>Organism:  &nbsp;".$org."</li></ul>";

	# Command : extraction des donn�es
	my $result=$RH_WEBBUILDER->GetSessionPath()."/SearchFamilies.xhtml";
	system "rm -f $result";

	
	my $url = $RH_WEBBUILDER->GetUrl("__wb_function");
	my $param=" --stringparam url '".$url."' --stringparam fnt DisplayFamily --stringparam org '".$org."'";
	
	my $cmd;
	print '<h2 class="learn">Results:</h2>';

	print '<center><table class="presentation">	<tbody><tr class="head">
	<th>Family acc</th><th>Computed Id</th><th>DbxRef</th><th>Members</th><th>Length</th><th>Free energie</th>
	</tr>';
	my @lst=&GetLstOfFile($DIR_WORKSPACE."/".$O_PARAM_CGI->Get("cgi_dir_rnaml_family"),$keyword,$id_el);
		foreach my $file (@lst )
		{
			$cmd = $O_PARAM_CGI->Get('cgi_prg_xsl')." $param $cgi_dir_xsl/".$O_PARAM_CGI->Get('cgi_xsl_search_families') ." $file";
			#print $cmd."\n";
			system $cmd;
		}
	
	print '</tbody></table></center><br />	';
	print '</div>';
}

=head2 procedure GetLstOfFile

 Title        : GetLstOfFile
 Prerequisite : none
 Function     : From a keyword and a id , launch find command in a specific directory
 Args         : $dir   : directory
                $id_el : input id element
 		$keyword : input keyword

=cut

sub GetLstOfFile
{
	my ($dir,$keyword, $id_el)=@_;
	my $cmd = " find $dir -name \\*$id_el\\*.xml";
	if (defined($keyword) && $keyword ne "")
	{	
		$cmd .= " -exec grep -i -l $keyword \'{}\' \\;";
	}
	my @lst= `$cmd`;
	return sort SortByAccession @lst;
}

=head2 procedure SortByAccession

 Title        : SortByAccession
 Prerequisite : none
 Function     : Function use in sort function of an array
 		sort by sequence accession then by id of rna on this sequence
 Args         :

=cut

sub SortByAccession
{
	my ($aid,$ar) = $a =~ /\/(\S+)_r(\d+)/; 
	my ($bid,$br) = $b =~ /\/(\S+)_r(\d+)/; 
	if ( $aid eq $bid )
	{
		return $ar <=> $br;
	}
	else
	{
		return $aid cmp $bid;
	}
}
################################
##### Formulaire analyse #######
################################

=head2 procedure PrintAnalyse

 Title        : PrintAnalyse
 Prerequisite : none
 Function     : Print form of an analyse
 Args         :

=cut


sub PrintAnalyse
{

	if ($O_AUTH->IsPrivilege('annotator')  )
	{
		&SelectWorkspace($O_PARAM_WB->Get('__wb_main_menu'),$O_PARAM_WB->Get('__wb_function') );
		print "<br />";
		my $str_input='';
		if ($O_PARAM_WB->Get('__wb_workspace') eq "private")
		{
			$str_input='<input  type="submit" name="synchronise" value="Synchronise library" class="button">';
		}
		&PrintForm($O_PARAM_WB->Get('__wb_main_menu'), "PrintAnalyse",$str_input);
	}
	if ($O_PARAM_WB->IsDefined('synchronise') )
	{
		# FERME LE FLUX
		my ($oldout, $olderr) = &CloseStd();
		&SynchroniseLibrary();
		&OpenStd($oldout, $olderr);
	}
	print '<h1  class="learn">Search your fasta sequence againt the LeARN library</h1>';
	my $cgi = $RH_WEBBUILDER->GetCgi();
	print '<div name="learn" class="div_learn">';
	print '<FORM enctype="multipart/form-data" action="'.$cgi.'" method="post">';
		print '<p><TABLE class="presentation" >';
			print '<tr>';
				print '<td>';
					print '<LABEL class="label_seq">Sequence : </LABEL>';
				print '</td>';
				print '<td>';
					print '<textarea name="input_seq" rows="10" class="saisie_seq"></textarea><br />';
					print '<LABEL class="labelExample">e.g: GCCCCGGUGGCUCAGCCUGGUAGAGCGGCCGCUUGGUAAGCGGCAGGUCCCGGGUUCAAAGCCCGGCCGGGGCU </LABEL>';
				print '</td>';
			print '</tr>';
			print '<tr>';
				print '<td>';
					print '<LABEL class="label_seq">Upload from disk : </LABEL>';
				print '</td>';
				print '<td>';
					print '<INPUT type="file" size="48" name="input_seq_browse" class="saisie_num" value="Browse"/>';
				print '</td>';
			print '</tr>';
			print '<tr>';
				print '<td>';
					print '<LABEL class="label_seq"/>';
				print '</td>';
				print '<td>';
					print '<LABEL class="label_seq">From : <INPUT type="text" name="input_seq_start" class="saisie_num"/> To : <INPUT type="text" name="input_seq_end" class="saisie_num"/></LABEL>';					
				print '</td>';
			print '</tr>';
		print '</TABLE></p>';
	my $str_input= '<center><INPUT type="submit" value="Send" class="button" >
		<INPUT type="reset" class="button" value="Reset"  /></center><br/><i>Uses the <a href="http://www.sanger.ac.uk/Software/Rfam/help/scripts/search/rfam_scan.pl">rfam_scan.pl</a> search engine</i>';
	&PrintForm($O_PARAM_WB->Get('__wb_main_menu'), "PrintResultSearchSequence",$str_input, "NoAction");
	print '</div>';
}

=head2 procedure PrintResultSearchSequence

 Title        : PrintResultSearchSequence
 Prerequisite : none
 Function     : Launch the analyse on the input sequence.

=cut



sub PrintResultSearchSequence
{
	my ($cmd, $head , $seq_data);
	my $sequence=$O_PARAM_WB->Get('input_seq');
	my $file=$O_PARAM_WB->Get('input_seq_browse');
	my $begin=$O_PARAM_WB->Get('input_seq_start');
	my $end=$O_PARAM_WB->Get('input_seq_end');
	my $session_dir=$RH_WEBBUILDER->GetSessionPath();
	my @a_T;
	if ($file ne "")
	{	
		@a_T = <$file>;
	}
	elsif ($sequence ne "")
	{
		@a_T=split (/[\r\n]+/,$sequence);
	}
		foreach my $line (@a_T)
		{	
			chomp($line);
			if ($line =~ /^\s*>/ ) 
			{	
				last if ( $head ne "" );
				my @a_H=split(" ",$line);
				$head=$a_H[0];
			}
			else
			{
				$seq_data.=$line;
			}
		}

	if ($begin ne "" && $end ne "" )
	{
			my $tmp=substr($seq_data,$begin, abs($end-$begin));	
			$seq_data=$tmp;
	}
	
	if (length($seq_data) > $O_PARAM_CGI->Get('cgi_param_max_sequence_size'))
	{
		print '<p class="error"> Sequence is too long, limited to '.$O_PARAM_CGI->Get('cgi_param_max_sequence_size').'</p>';
			print "<br />";
		my $str_input= '<center><INPUT type="submit" value="Return" class="button" ><center>';
		&PrintForm($O_PARAM_WB->Get('__wb_main_menu'), "PrintAnalyse",$str_input);
		print "<br />";
		return;
	}
	$head=~s/>//;
	$head="query$$" if ($head eq "");
	my $user_fasta_file = "$session_dir/$head.fa";	

	open (USER_FILE , ">$user_fasta_file") or print "Unable to open : >$user_fasta_file<" ;
	print USER_FILE ">$head\n";
	print USER_FILE $seq_data;
	close (USER_FILE);
	
	my $nb_sub_car=$O_PARAM_CGI->Get('cgi_param_substr');
	my $download_file=substr($user_fasta_file,$nb_sub_car-1);
	print '<h1  class="learn">Scan LeARN library</h1>';
	
	print '<div class="div_learn">';
	print '<h2  class="learn">Computing ...</h2>';
	print '<p class="text1">Please wait few minutes.<br />
	<a href='.$download_file.' target=new> Your sequence data </a></p>';
	my $cfgFile=&MakeCfg($O_PARAM_CGI->Get('cgi_param_learn_cfg'),$session_dir, $DIR_WORKSPACE, $O_PARAM_CGI->Get('cgi_mask_cfg_release'), $O_PARAM_CGI->Get('cgi_mask_cfg_old_release'), "Search");
	
	my $cde = $O_PARAM_CGI->Get('cgi_prg_learn_search_rna')." --cfg $cfgFile ".$O_PARAM_CGI->Get('cgi_param_learn') ." --input_fasta $user_fasta_file --dir_rfam $DIR_WORKSPACE/".$O_PARAM_CGI->Get('cgi_dir_db_rfl4rfamscan')." > $user_fasta_file.stdout"; 
	#print $cde;
	system($cde) ;
	#on nerecup�re que le fichier concernant la s�quence que l'on viens d'analyser
	print '<h2  class="learn">Result...</h2>';
	my $xml_dir="$session_dir/".$O_PARAM_CGI->Get('cgi_dir_rnaml_rna');
	&PrintBrowseAnalyzed($xml_dir, $head);
	print "<br />";
	my $str_input= '<center><INPUT type="submit" value="Return" class="button" ><center>';
	&PrintForm($O_PARAM_WB->Get('__wb_main_menu'), "PrintAnalyse",$str_input);
	print "<br />";
	
}

=head2 procedure SynchroniseLibrary

 Title        : SynchroniseLibrary
 Prerequisite : none
 Function     : Launch perl script which load all xml file form workspace and dump rfl db.

=cut

sub SynchroniseLibrary
{
	my $cfgFile=&MakeCfg($O_PARAM_CGI->Get('cgi_param_learn_cfg'),$RH_WEBBUILDER->GetSessionPath(), $DIR_WORKSPACE, $O_PARAM_CGI->Get('cgi_mask_cfg_release'), $O_PARAM_CGI->Get('cgi_mask_cfg_old_release'), "Sybchronise");
	
	my $cde = $O_PARAM_CGI->Get('cgi_prg_learn_synchronise_rfl')." --cfg $cfgFile ".$O_PARAM_CGI->Get('cgi_param_learn'); 
	#print $cde;
 	system $cde;
}

=head2 procedure PrintBrowseAnalyzed

 Title        : PrintBrowseAnalyzed
 Prerequisite : none
 Function     : Print array of rna found on input sequence analysed

=cut
sub PrintBrowseAnalyzed
{
	
	my ($xml_dir, $head)=@_;
	my $result;
	$result=$RH_WEBBUILDER->GetSessionPath()."/ViewingAnalyseRnas$head.xhtml";
	
	if (!-e $result || -z $result)
	{# Command : extraction des donn�es
		
		my $url = $RH_WEBBUILDER->GetUrl("__wb_function,__wb_workspace");

		my $param=" --stringparam url '".$url."' --stringparam fnt_rna DisplayRna --stringparam fnt_family DisplayFamily  --stringparam wks_rna session --stringparam wks_family '".$O_PARAM_WB->Get('__wb_workspace')."' --stringparam wks_previous ".$O_PARAM_WB->Get("__wb_workspace");
	
		
		my $cmd = "find $xml_dir -name '*.xml' -exec ". $O_PARAM_CGI->Get('cgi_prg_xsl')." $param $cgi_dir_xsl/". $O_PARAM_CGI->Get('cgi_xsl_print_analyzed_rnas') ." \'{}\' \\; > $result";
		# voir si on redirige dans result ou pas!
		#print $cmd;
		`$cmd`;
	}
	if (-e $result &&  ! -z $result)
	{
		print '<center><table class="presentation">	<tbody>	<tr class="head">
		<th></th><th>RNA acc</th><th>Id</th><th>Family</th><th>Genbank</th><th>Start</th><th>End</th><th>Program</th><th>Free energy</th>
		</tr>';
		&DisplayResult($result, "numbering");
		print '</tbody></table></center>';
	}
	else
	{
		print '<p class="error">No result</p>';
	}
}







=head2 procedure PrintHomepage

 Title        : PrintHomepage
 Prerequisite : none
 Function     : Print home page

=cut


sub PrintHomepage
{
#	print '<center><img src="/LeARN/web/img/LeARNHomePageV3.jpg"><br />';
#	print '<LABEL class="labelExample">Image from : http://wa.wikipedia.org</LABEL></center>';

	my $abstract_file = $O_PARAM_CGI->Get('dir_learn')."/cfg/abstract.inc";
	if ( -e "$abstract_file" )
	{
		my @a_abstract = `cat $abstract_file`;
		print @a_abstract;
	}
	&PrintDBStatus();
}

=head2 procedure PrintHelp

 Title        : PrintHelp
 Prerequisite : none
 Function     : Print help

=cut

sub PrintHelp
{
	print '<h1 class="learn">Help</h1>';
	
	#&Trace();
}

=head2 procedure PrintCredit

 Title        : PrintCredit
 Prerequisite : none
 Function     : Print credit

=cut
sub PrintCredit
{
print '
	<h2 class="learn" > <a class="title" href=http://www.toulouse.inra.fr/centre/lipm target=new>Laboratoire des Interactions Plantes Microorganismes - INRA/CNRS</A></h2>
	J&eacute;r&ocirc;me Gouzy, C&eacute;line Noirot<br />
	<br/>
	<h2 class="learn" > <a class="title" href=http://www.inra.fr/bia target=new>Laboratoire de Biom&eacute;trie et d\'Intelligence Artificielle - INRA </a></h2>
	Christine Gaspin, Thomas Schiex<br />
	<br/>
	<h2 class="learn" >Financial support</h2> 
	EU-FP6 Grain Legumes IP (C&eacute;line Noirot)
	<br/>
	<br/>
	<h2 class="learn" >Project information</h2> 
	<ul>
	<li>Questions and comments: <a href="mailto:learnATtoulouse.inra.fr?Subject=LeARN">contact us</a>
	<li>Roadmap, bug reports, related software and databases, etc.: <a href="http://bioinfo.genopole-toulouse.prd.fr/LeARN">http://bioinfo.genopole-toulouse.prd.fr/LeARN</a>
	</ul>
	';							
if (0)
	{

	print '<FORM action="'.$RH_WEBBUILDER->GetCgi().'" method="post">';
	print '  dir to delete : <INPUT type="text" name="session_dir"  >
				<INPUT type="submit" value="Send" class="button" >
				<INPUT name="__wb_main_menu" value="'.$O_PARAM_WB->Get('__wb_main_menu').'" type="hidden" >
				<INPUT name="__wb_function" value="DeleteDir" type="hidden" >
				<INPUT name="__wb_session" value="'.$O_PARAM_WB->Get('__wb_session').'" type="hidden" >
				<INPUT name="__wb_workspace" value="'.$O_PARAM_WB->Get('__wb_workspace').'" type="hidden" >
				<INPUT name="__wb_xmlstructure" value="'.$O_PARAM_WB->Get('__wb_xmlstructure').'" type="hidden" >
				<INPUT name="__wb_cookie" value="'.$O_AUTH->GetCookie().'" type="hidden" >
				</FORM>';		

		
	print '<FORM action="'.$RH_WEBBUILDER->GetCgi().'" method="post">';
	print ' Session dir : <INPUT type="text" name="session_dir"  >
				<INPUT type="submit" value="Send" class="button" >
				<INPUT name="__wb_main_menu" value="'.$O_PARAM_WB->Get('__wb_main_menu').'" type="hidden" >
				<INPUT name="__wb_function" value="ChmodDir" type="hidden" >
				<INPUT name="__wb_session" value="'.$O_PARAM_WB->Get('__wb_session').'" type="hidden" >
				<INPUT name="__wb_workspace" value="'.$O_PARAM_WB->Get('__wb_workspace').'" type="hidden" >
				<INPUT name="__wb_xmlstructure" value="'.$O_PARAM_WB->Get('__wb_xmlstructure').'" type="hidden" >
				<INPUT name="__wb_cookie" value="'.$O_AUTH->GetCookie().'" type="hidden" >
		</FORM>';		
	
}
}

sub DumpFamilyFiles
{
my ($o_family) = @_;

	$o_family->DumpFasta();
	$o_family->DumpClustal();
	$o_family->DumpStockholm();
	$o_family->DumpMss();
	$o_family->ComputeStructure();
	$o_family->ImproveSS();
	$o_family->BuildCm();
}

sub DeleteDir
{
	my $session_dir = $O_PARAM_WB->Get('session_dir');
	#my $cmd="rm -rf $session_dir";
	my $cmd="rm -rf $session_dir";
	#print $cmd;
	system $cmd;
}

sub ChmodDir
{
	my $session_dir = $O_PARAM_WB->Get('session_dir');
	#my $cmd="rm -rf $session_dir";
	my $cmd="chmod -R 777 $session_dir";
	#print $cmd;
	system $cmd;
}
################################
############ Trace #############
################################

sub Trace
{
	$O_PARAM_WB->Print('html');
	print "<pre>";
	$RH_WEBBUILDER->__Dump();
	print "</pre>";
}

