#
# $Id$
#

# Copyright INRA

# Celine.Noirot@toulouse.inra.fr
# Thomas.Schiex@toulouse.inra.fr
# Christine.Gaspin@toulouse.inra.fr
# Jerome.Gouzy@toulouse.inra.fr

# This software is a computer program whose purpose is to provide a
# web-based system for detecting, clustering and annotating non protein
# coding RNA genes.

# This software is governed by the CeCILL license under French law and
# abiding by the rules of distribution of free software.  You can  use,
# modify and/ or redistribute the software under the terms of the CeCILL
# license as circulated by CEA, CNRS and INRIA at the following URL
# "http://www.cecill.info".

# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability.

# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or
# data to be ensured and,  more generally, to use and operate it in the
# same conditions as regards security.

# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL license and that you accept its terms.
 
package rnaml::reference::reference;

use base qw/Class::XML/;
__PACKAGE__->element_name('reference');
__PACKAGE__->has_attributes(qw/id comment/);
__PACKAGE__->has_parent('rnaml::rnaml');
__PACKAGE__->has_children('author' => person);
__PACKAGE__->has_children('title' => 'title');
__PACKAGE__->has_children('journal' => 'journal');
__PACKAGE__->has_children('date' => 'date');
__PACKAGE__->has_children('pubmed_id' => 'pubmed_id');
__PACKAGE__->has_children('book_title' => 'book_title');
__PACKAGE__->has_children('editor' => 'editor');
__PACKAGE__->has_children('volume' => 'volume');
__PACKAGE__->has_children('issue' => 'issue');
__PACKAGE__->has_children('pages' => 'pages');
__PACKAGE__->has_children('path' => 'path');

1;
